<?php
/****************************************************************************
* ExBB v.1.1                                                              	*
* Copyright (c) 2002-20 by Alexander Subhankulov aka Warlock            	*
*                                                                         	*
* http://www.exbb.net                                             			*
* email: admin@exbb.net                                           			*
*                                                                         	*
****************************************************************************/
/****************************************************************************
*                                                                         	*
*   This program is free software; you can redistribute it and/or modify  	*
*   it under the terms of the GNU General Public License as published by  	*
*   the Free Software Foundation; either version 2 of the License, or     	*
*   (at your option) any later version.                                   	*
*                                                                         	*
****************************************************************************/
include('common.php');

$vars = parsed_vars();

include($exbb['home_path'] . 'language/' . $exbb['default_lang'] . '/lang_news.php');

if (isset($vars['action']) && $vars['action'] == 'delete') {
    if (!defined('IS_ADMIN')) error($lang['Announ'],$lang['Not_admin']);
	if ($vars['request_method'] == 'post') {
        $fp_news = NULL; $newsfile = $exbb['home_path'].'data/news.php';
    	$announcements = Get_File_Data($fp_news,$newsfile);

    	unset($announcements[$vars['number']]);
    	# Write it back minus the one to delete.
    	save_opened_file($fp_news,$announcements);

		/* ////  For fix zeros bugs  //// */
    	clearstatcache();
    	send_bugs(__FILE__,__LINE__,array($newsfile),4);
    	/* ////  For fix zeros bugs  //// */

    	$relocurl = 'announcements.php';
    	$title_page = $exbb['boardname'].' :: '.$lang['Ann_deleted'];
    	$ok_title = $lang['Ann_deleted'];
    	$url1 = '<b>'.$ok_title.'</b>';
    	$url2 = '<li><a href="'.$relocurl.'">'.$lang['Ann_return'].'</a>';
    	$url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
    	include('./templates/'.$exbb['default_style'].'all_header.tpl');
    	include('./templates/'.$exbb['default_style'].'postok.tpl');
    	include('./templates/'.$exbb['default_style'].'footer.tpl');
    	include('page_tail.php');
    } else {
            $formtitle      = $lang['DelRequesting'];
            $title_page 	= $exbb['boardname'].' :: '.$lang['DelRequesting'];
            $requestscript 	= 'announcements.php';
            $hiddinfield    = '<input name="action" type="hidden" value="delete">
							   <input name="save" type="hidden" value="1">
							   <input name="number" type="hidden" value="'.$vars['number'].'">';
           	$request_text   = $lang['Ann_SureDel'].$lang['RequestThisAction'];
    		include('./templates/'.$exbb['default_style'].'all_header.tpl');
    		include('./templates/'.$exbb['default_style'].'request_form.tpl');
    		include('./templates/'.$exbb['default_style'].'footer.tpl');
    		include('page_tail.php');
    }
} elseif (isset($vars['action']) && $vars['action'] == 'delall') {
		if (!defined('IS_ADMIN')) {error($lang['Announ'],$lang['Not_admin']);}
        if ($vars['request_method'] == 'post') {
     		$fp_news = NULL; $newsfile = $exbb['home_path'].'data/news.php';
     		$announcements = Get_File_Data($fp_news,$newsfile);
        	save_opened_file($fp_news,array());

     		$relocurl = 'announcements.php';
     		$title_page = $exbb['boardname'].' :: '.$lang['Ann_del_all'];
     		$ok_title = $lang['Ann_del_all'];
     		$url1 = '<b>'.$ok_title.'</b>';
     		$url2 = '<li><a href="'.$relocurl.'">'.$lang['Ann_return'].'</a>';
     		$url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
     		include('./templates/'.$exbb['default_style'].'all_header.tpl');
     		include('./templates/'.$exbb['default_style'].'postok.tpl');
     		include('./templates/'.$exbb['default_style'].'footer.tpl');
     		include('page_tail.php');
    	} else {
            	$formtitle      = $lang['DelRequesting'];
            	$title_page 	= $exbb['boardname'].' :: '.$lang['DelRequesting'];
            	$requestscript 	= 'announcements.php';
            	$hiddinfield    = '<input name="action" type="hidden" value="delall">
							   <input name="save" type="hidden" value="1">';
           		$request_text   = $lang['Ann_SureDelAll'].$lang['RequestThisAction'];
    			include('./templates/'.$exbb['default_style'].'all_header.tpl');
    			include('./templates/'.$exbb['default_style'].'request_form.tpl');
    			include('./templates/'.$exbb['default_style'].'footer.tpl');
    			include('page_tail.php');
    	}
} elseif (isset($vars['action']) && $vars['action'] == 'add') {
		if (!defined('IS_ADMIN')) {error($lang['Announ'],$lang['Not_admin']);}
     	$do = 'doadd';
     	$codemap = '<br><script language="JavaScript">ibcodes();</script>';
     	$smilesmap = '<br><script language="JavaScript">ibsmiles();</script>';
     	$java = '<script language="Javascript" src="smilesmap.js"></script><script language="Javascript" src="codesmap.js"></script>';
     	include('./templates/'.$exbb['default_style'].'news_add.tpl');
} elseif (isset($vars['action']) && $vars['action'] == 'doadd') {
		if (!defined('IS_ADMIN')) {error($lang['Announ'],$lang['Not_admin']);}
     	$currenttime = time();

     	# Check for blanks.
      	if ($vars['inpost'] == '') { error($lang['Announ'],$lang['Ann_enter_need']);}
     	if ($vars['title'] == '') { error($lang['Announ'],$lang['Ann_title_need']);}

     	# Get the announcement file and block it
        $fp_news = NULL; $newsfile = $exbb['home_path'].'data/news.php';
     	$announcements = Get_File_Data($fp_news,$newsfile);
        $announcements[$currenttime]['t'] = soft_clr_value($_POST['title']);
     	$announcements[$currenttime]['p'] = soft_clr_value($_POST['inpost']);
     	save_opened_file($fp_news,$announcements);

        /* ////  For fix zeros bugs  //// */
    	clearstatcache();
    	send_bugs(__FILE__,__LINE__,array($newsfile),5);
    	/* ////  For fix zeros bugs  //// */

     	$relocurl = 'announcements.php';
     	$title_page = $exbb['boardname'].' :: '.$lang['Ann_added'];
     	$ok_title = $lang['Ann_added'];
     	$url1 = '<li><b>'.$ok_title.'</b>';
     	$url2 = '<li><a href="'.$relocurl.'">'.$lang['Ann_return'].'</a>';
     	$url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
     	include('./templates/'.$exbb['default_style'].'all_header.tpl');
     	include('./templates/'.$exbb['default_style'].'postok.tpl');
     	include('./templates/'.$exbb['default_style'].'footer.tpl');
     	include('page_tail.php');
} elseif (isset($vars['action']) && $vars['action'] == 'edit') {
		if (!defined('IS_ADMIN')) {error($lang['Announ'],$lang['Not_admin']);}

        # Get the announcement file
        $hidden = '<input type=hidden name="number" value="'.$vars['number'].'">';
        $newsfile = $exbb['home_path'].'data/news.php';
        $announcements = get_file($newsfile);

        # Get the announcement to edit

        $title = $announcements[$vars['number']]['t'];
        $post = $announcements[$vars['number']]['p'];

        # Clean the text area

        $post = str_replace('<p>',"\n\n",$post);
        $post = str_replace('<br>',"\n",$post);
        $do = 'doedit';
        $codemap = '<br><script language="JavaScript">ibcodes();</script>';
        $smilesmap = '<br><script language="JavaScript">ibsmiles();</script>';
        $java = '<script language="Javascript" src="smilesmap.js"></script><script language="Javascript" src="codesmap.js"></script>';
        # Present the form
        include('./templates/'.$exbb['default_style'].'news_add.tpl');
} elseif (isset($vars['action']) && $vars['action'] == 'doedit') {
		if (!defined('IS_ADMIN')) {error($lang['Announ'],$lang['Not_admin']);}
        $currenttime = time();

        # Check for blanks.
        if ($vars['inpost'] == '') { error($lang['Announ'],$lang['Ann_enter_need']);}
        if ($vars['title'] == '') { error($lang['Announ'],$lang['Ann_title_need']);}

        # Get the announcement file
        $fp_news = NULL; $newsfile = $exbb['home_path'].'data/news.php';
     	$announcements = Get_File_Data($fp_news,$newsfile);

        unset($announcements[$vars['number']]);
        # Write it back with the new announcement at the top

        $announcements[$currenttime]['t'] = soft_clr_value($_POST['title']);
        $announcements[$currenttime]['p'] = soft_clr_value($_POST['inpost']);
        save_opened_file($fp_news,$announcements);

        /* ////  For fix zeros bugs  //// */
    	clearstatcache();
    	send_bugs(__FILE__,__LINE__,array($newsfile),6);
    	/* ////  For fix zeros bugs  //// */

        $relocurl = 'announcements.php';
        $title_page = $exbb['boardname'].' :: '.$lang['Ann_edited'];
        $ok_title = $lang['Ann_edited'];
        $url1 = '<li><a href="'.$relocurl.'">'.$lang['Ann_return'].'</a>';;
        $url2 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
        $url3 = null;
        include('./templates/'.$exbb['default_style'].'all_header.tpl');
        include('./templates/'.$exbb['default_style'].'postok.tpl');
        include('./templates/'.$exbb['default_style'].'footer.tpl');
        include('page_tail.php');
} else { ### start displaying the announcements.
		$newsfile = $exbb['home_path'].'data/news.php';
        $announcements = get_file($newsfile);
        $totals = (is_array($announcements)) ? count($announcements) : 0;

         if ($totals == 0) {
            $dateposted = time();
            $announcements[$dateposted]['t'] = $lang['Ann_no'];
            $announcements[$dateposted]['p'] = ' ';
         }
         $adminadd = (defined('IS_ADMIN')) ?  ' :: <a href="announcements.php?action=delall" onClick="DelNews(\'delall\');return false;">'.$lang['Ann_dellall'].'</a> :: <a href="announcements.php?action=add">'.$lang['Ann_add'].'</a>' : '';
         krsort($announcements);
         foreach ($announcements as $id=>$info) {
            	$dateposted = longDate($id+$exbb['usertime']*3600);
            	$title = $info['t'];
            	$post = $info['p'];
            	$post = ikoncode($post);
            	$post = setsmiles($post);
            	include('./templates/'.$exbb['default_style'].'news_data.tpl');
         } //foreach
} // end last else
$title_page = $exbb['boardname'].' :: '.$lang['Announ'];
include('./templates/'.$exbb['default_style'].'all_header.tpl');
include('./templates/'.$exbb['default_style'].'logos.tpl');
include('./templates/'.$exbb['default_style'].'news_show.tpl');
include('./templates/'.$exbb['default_style'].'footer.tpl');
include('page_tail.php');
?>
