<?php
/****************************************************************************
* ExBB v.1.1                                                              	*
* Copyright (c) 2002-20 by Alexander Subhankulov aka Warlock            	*
*                                                                         	*
* http://www.exbb.net                                             			*
* email: admin@exbb.net                                           			*
*                                                                         	*
****************************************************************************/
/****************************************************************************
*                                                                         	*
*   This program is free software; you can redistribute it and/or modify  	*
*   it under the terms of the GNU General Public License as published by  	*
*   the Free Software Foundation; either version 2 of the License, or     	*
*   (at your option) any later version.                                   	*
*                                                                         	*
****************************************************************************/
include('common.php');

$vars = parsed_vars();

$allforumsfile = $exbb['home_path'].'data/allforums.php';
$allforums = get_file($allforumsfile);

if ( isset($vars['action']) && $exbb['reged']) {
    mark_board();
    exit;
}
$news_data = null;
if ($exbb['announcements']) {
	$newsfile = $exbb['home_path'].'data/news.php';
    $news = get_file($newsfile);
    if (is_array($news) && count($news)) {
    	krsort($news);
        reset($news);
        $dateposted = key($news);
        $titlenews = $news[$dateposted]['t'];
        unset($news);
        $dateposted += $exbb['usertime'] * 3600;
        $dateposted = date("d.m.Y",$dateposted);
        include('./templates/'.$exbb['default_style'].'news.tpl');
        unset($titlenews,$dateposted);
    }
} #end announs

if (isset($vars['c'])) {
    $arr_tmp = array();
    foreach ($allforums as $id=>$forum){
             if ($vars['c'] == $forum['catid']) $arr_tmp[$id] = $forum;
    }
    $allforums = array();
    $allforums = $arr_tmp;
    $arr_tmp = array();
}

$l_v = $exbb['last_visit'];
$board_data = '';
$lastcategoryplace = -1;

foreach ($allforums as $id=>$forum){
		if (!defined('IS_ADMIN')) {
           	if (!$inuser['private'][$id] && $forum['private'])  continue;
   		}
   		$arr_tmp[$id] = $forum;
}
$allforums = $arr_tmp;
unset($arr_tmp);
$_COOKIE['t_visits'] = isset($_COOKIE['t_visits']) ? $_COOKIE['t_visits']:"a:0:{}";
$t_visits = (get_magic_quotes_gpc())  ? unserialize(stripslashes($_COOKIE['t_visits'])):unserialize($_COOKIE['t_visits']);
#XXXXXXXXXXXXXXXXXXXX -  XXXXXXXXXXXXXXXXXXXXXXXXXXXX
if ($exbb['threadstop'] === 1){
	include ($exbb['home_path'].'modules/threadstop/threadstop_before.php');
}
#XXXXXXXXXXXXXXXXXXXX -  XXXXXXXXXXXXXXXXXXXXXXXXXXXX
foreach ($allforums as $id=>$forum) {
        $threads 	= $forum['topics'];
   		$posts 		= $forum['posts'];
   		$category 	= $forum['catname'];
   		$in_cat		= $forum['catid'];

        #XXXXXXXXXXXXXXXXXXXX -  XXXXXXXXXXXXXXXXXXXXXXXXXXXX
        if ($exbb['threadstop'] === 1){
            threadstop_foreach();
        }
        #XXXXXXXXXXXXXXXXXXXX -  XXXXXXXXXXXXXXXXXXXXXXXXXXXX
        $flag = FALSE;
        if ($exbb['reged']) {
       		$f_readed = (isset($_COOKIE['f'.$id])) ? $_COOKIE['f'.$id] : 0;
       		$f_readed = $f_readed > $exbb['last_visit'] ? $f_readed : $exbb['last_visit'];
            if ($forum['last_time'] > $exbb['last_visit']) {
            	if ($exbb['threadstop'] === 0){
            		$alltopic = array();
            		$alltopic = get_file($exbb['home_path'].'forum'.$id.'/list.php');
            	}
        		if (sizeof($alltopic) > 0) {
        			$alltopic 	= array_filter($alltopic, "NEW_POSTS");
            		$flag		= (sizeof($alltopic) >0)?TRUE:FALSE;
        		}
        	}
            unset($alltopic);
        }

        $lang_moder = $modoutput = '';

        if (!empty($forum['moderator'])) moderator($id,$allforums);

   		$catrow = ($forum['catid'] != $lastcategoryplace) ? true : false;

   		$forumname = '<a href="forums.php?forum='.$id.'">'.stripslashes($forum['name']).'</a>';
   		$forumdescription = stripslashes($forum['desc']);

        $yes_forumicon = (!empty($forum['icon'])) ? './im/images/'.$forum['icon']:'./templates/'.$exbb['default_style'].'im/foldernew.gif';
		$no_forumicon  = (!empty($forum['icon'])) ? './im/images/no_'.$forum['icon']:'./templates/'.$exbb['default_style'].'im/folder.gif';
   		if (isset($forum['last_time']) && $exbb['reged']) {
            $folderpicture = ($flag === TRUE) ? '<img src="'.$yes_forumicon.'" border="0">' : '<img src="'.$no_forumicon.'" border="0">';
   		} else {
           		$folderpicture = '<img src="'.$no_forumicon.'" border="0">';
           		$loginmessage = $lang['Marked_posts'];
   		}

   		$forumlastpost =  ( !empty($forum['last_time']) ) ? date("d.m.Y - H:i", $forum['last_time'] + $exbb['usertime']*3600) : $lang['NA'];

   		$lastposterfilename = $forum['last_poster'];

   		$lastpost = '';
   		if (isset($forum['last_post'])) {
     		$savet = $forum['last_post'];
     		if (strlen($savet)>36) {$savet = substr($savet,0,35).'...';}
     		$lastpost = '<img src="./templates/'.$exbb['default_style'].'im/lastpost.gif"> <a href="topic.php?forum='.$id.'&topic='.$forum['last_post_id'].'&v=l#'.$forum['last_key'].'" title="'.$forum['last_post'].'">'.$savet.'</a>';
   		}

   		$private = '<br>'.$lastpost.'<br>'.$lang['Author'].': ';
   		$private .= ( $forum['last_poster_id'] ) ? '<a href="profile.php?action=show&member='.$forum['last_poster_id'].'">'.$forum['last_poster'].'</a>' : $lang['Unreg'];

  		$lastcategoryplace = $forum['catid'];
  		$next = next($allforums);
  		$last = ( !$next || $next['catid'] != $forum['catid'] ) ? true : false;
		include ('./templates/'.$exbb['default_style'].'board_data.tpl');
}

include ('./data/boardstats.php');
extract(whosonline($lang['ExBB_main'],FALSE,TRUE));
$max_users = max_online();
$max_users[0] = intval($max_users[0]);

#XXXXXXXXXXXXXXXXXXXX      XXXXXXXXXXXXXXXXXXXXXXXXXXXX
if ($exbb['visiblemode'] == 1) {
	include ($exbb['home_path'].'modules/visiblemode/language/'.$exbb['default_lang'].'/lang.php');
    $countonline  = sprintf($lang['VSB_OnlineVSHide'],$exbb['membergone'],array_sum($total_users),$total_users['guests'],$total_users['members'],$total_users['hiddens']);
} else {//END Invisible Mode Module
		$countonline  = sprintf($lang['online_data'],$exbb['membergone'],array_sum($total_users),$total_users['members'],$total_users['guests']);
}

$online_last = $countonline . ' [ <font color=red>'.$lang['Admin'].'</font>, <font color=green>'.$lang['Moderator'].'</font> ]';
$maximum = sprintf($lang['Max_users'],$max_users[1]).date("d.m.Y H:i",$max_users[0]+$exbb['usertime']*3600);

$basetimes = longdate(time() + $exbb['usertime'] * 3600);

$exbb['last_visit'] = $l_v;
$rowspan = 1;
$title_page = $exbb['boardname'];
#XXXXXXXXXXXXXXXXXXXX -  XXXXXXXXXXXXXXXXXXXXXXXXXXXX
$threadstop = NULL;
if ($exbb['threadstop'] === 1){
	include ($exbb['home_path'].'modules/threadstop/threadstop.php');
}
#XXXXXXXXXXXXXXXXXXXX -  XXXXXXXXXXXXXXXXXXXXXXXXXXXX
#XXXXXXXXXXXXXXXXXXXX -  XXXXXXXXXXXXXXXXXX
$userstop = NULL;
if ($exbb['userstop'] === 1){
	include ($exbb['home_path'].'modules/userstop/userstop.php');
    $rowspan++;
}
#XXXXXXXXXXXXXXXXXXXX -  XXXXXXXXXXXXXXXXXX
#XXXXXXXXXXXXXXXXXXXX   XXXXXXXXXXXXXXXXXXXXXXXXXXX
$birstdaylist = NULL;
if ($exbb['birstday'] === 1){
	include ($exbb['home_path'].'modules/birstday/birst.php');
    $title_page = $title_page.' '.$birsdaytitle;
    $rowspan++;
}
#XXXXXXXXXXXXXXXXXXXX   XXXXXXXXXXXXXXXXXXXXXXXXXXX
$lastvisit = longdate($exbb['last_visit'] + $exbb['usertime'] * 3600);
$link = $newmail = null;
if ($inuser['new_pm']) include('./templates/'.$exbb['default_style'].'newmail.tpl');

include('./templates/'.$exbb['default_style'].'all_header.tpl');
include('./templates/'.$exbb['default_style'].'logos.tpl');
include('./templates/'.$exbb['default_style'].'board_body.tpl');
include('./templates/'.$exbb['default_style'].'footer.tpl');
include('page_tail.php');
?>
