<?php
/***************************************************************************
* "Punishment of the user" mods for  ExBB v.1.9.1                          *
* Copyright (c) 2004 by Alisher Mutalov aka Markus                        *
*                                                                          *
* http://www.tvoyweb.ru                                                    *
* http://www.tvoyweb.ru/forums/                                            *
* email: admin@tvoyweb.ru                                                  *
*                                                                          *
***************************************************************************/
include('common.php');

$vars = parsed_vars();

include($exbb['home_path'].'modules/punish/language/'.$exbb['default_lang'].'/lang.php');
include($exbb['home_path'].'modules/punish/data/punish_data.php');
$forum = get_file($exbb['home_path'].'data/allforums.php',FALSE);

$infopun = $vars['info'];
list($in_f,$in_t,$in_k,$in_m,$p) = explode('::',$infopun);

$topic = get_file($exbb['home_path'].'forum'.$in_f.'/list.php',FALSE);
$who = (defined('IS_ADMIN')) ? 'Ad':'Mod';
$inmembmod = moderator($in_f,$forum);
$fp_pun = NULL; $punneduserfile = $exbb['home_path'].'members/'.$in_m.'.php';
$punneduser = Get_File_Data($fp_pun,$punneduserfile,FALSE);

$punned_name = $punneduser['name'];
$p_total = $punneduser['total_pun'];
$p_time = (time()-$punneduser['time_pun'])/86400;

$pm_main = sprintf($lang['Pm_Main_Pun'],$in_f,$forum[$in_f]['name'],$in_f,$in_t,$p,$in_k,$topic[$in_t]['name']);

switch ($p_total){
		case 4	: $pm_message = $lang['Pm_LastPun_Mess'];					break;
        case 3	: $pm_message = sprintf($lang['Pm_SomeBlockPun_Mess'],$pt4);break;
        case 2	: $pm_message = sprintf($lang['Pm_SomeBlockPun_Mess'],$pt3);break;
        default	: $pm_message = $lang['Pm_ButYou_May'];
}
if (defined('IS_ADMIN') || $inmembmod) {
	if (isset($vars['action'])){
    	$user_select = true;
        $acces = true;
        if ($vars['action']=='pun'){
        	if (isset($punneduser['punned'])){
                if ($p_total==5){
                    fclose($fp_pun);
                 	$information = sprintf($lang['Cant_Punned_PunEmpty'],$punned_name);
              	} elseif ($p_total==4 && $p_time<=$pt4){
                        fclose($fp_pun);
						$information = sprintf($lang['Cant_Punned_TimeNotEmpty'],$punned_name);
                } elseif ($p_total==3 && $p_time<=$pt3){
                        fclose($fp_pun);
                		$information = sprintf($lang['Cant_Punned_TimeNotEmpty'],$punned_name);
                } elseif (array_key_exists($infopun, $punneduser['punned'])) {
                        fclose($fp_pun);
                		list($names_pun,$st) = explode('::',$punneduser['punned'][$infopun]);
                        $status = ($st=='Ad') ? $lang['VS_Admin']:$lang['VS_Moder'];
                        $information = sprintf($lang['User_Punned_VS'],$status,$names_pun);
                } else {
                        $total_pun = $punneduser['total_pun'];
                        $keys = $in_f.'::'.$in_t.'::'.$in_k.'::'.$in_m.'::'.$p;
                        $whos = $exbb['member'].'::'.$who;
                        $punneduser['punned'][$keys]=$whos;
                        $punneduser['total_pun']= $total_pun+1;
                        $punneduser['time_pun']= time();
                        send_pm($in_m);
                        $information = $lang['Successful_Punned'];
                        save_opened_file($fp_pun,$punneduser);
                }
           	} else {
                    $keys = $in_f.'::'.$in_t.'::'.$in_k.'::'.$in_m.'::'.$p;
                  	$whos = $exbb['member'].'::'.$who;
                  	$punneduser['punned'][$keys]= $whos;
                  	$punneduser['total_pun']= 1;
                  	$punneduser['time_pun']= time();
                  	send_pm($in_m);
                  	$information = $lang['Successful_Punned'];
                    save_opened_file($fp_pun,$punneduser);
            }
            vivodim();
        } else { # 
        		if (array_key_exists($infopun, $punneduser['punned'])) {
                   	unset($punneduser['punned'][$infopun]);
                   	$punneduser['total_pun']--;
                   	if (count($punneduser['punned'])<=0)unset($punneduser['punned']);
                   	save_opened_file($fp_pun,$punneduser);
                   	$information = $lang['Pun_Removed'];
               	} else {
                        fclose($fp_pun);
                		$information = $lang['Pun_Del_Error'];
                }
                vivodim();
        }
    } elseif (isset($vars['info']) && !isset($vars['action'])){
            fclose($fp_pun);
            $user_select = true;
            $acces = true;
            foreach ($forum as $ids=>$name){
            	if ($ids==$in_f)$pf_name = $name['name'];
            }
            foreach ($topic as $tid=>$tname){
            		if ($tid==$in_t)$pt_name = $tname['name'];
            }
            $information = sprintf($lang['You_are_sure'],$punned_name,$pt_name,$pf_name,$infopun);
            if (isset($punneduser['punned']) && $punneduser['punned']!=0){
                vivodim();
            } else {
            		$punish_data = null;
            }
    } else {
            fclose($fp_pun);
    		$acces=true;
            $user_select = false;
            $access = $lang['Not_selected'];
    }
} else {
        fclose($fp_pun);
		$acces=false;
        $access = $lang['Forbidden'];
}
/* ////  For fix zeros bugs  //// */
clearstatcache();
send_bugs(__FILE__,__LINE__,array($punneduserfile),18);
/* ////  For fix zeros bugs  //// */

$title_page = $exbb['boardname'] .' :: '.$lang['Win_title'];
include('./templates/'.$exbb['default_style'].'all_header.tpl');
include('./templates/'.$exbb['default_style'].'/modules/punish/punish.tpl');
include('./templates/'.$exbb['default_style'].'footer.tpl');
include('page_tail.php');

function send_pm($id) {
		global $pm_main,$lang,$punneduser,$exbb,$punned,$pm_message;

        #    true
        $punneduser['new_pm'] = true;
        save_opened_file($punned,$punneduser);
        #  .
        $pmid = time();
        $from = (defined('IS_ADMIN')) ? $lang['Pun_Admin']:$lang['Pun_Moder'];
		$fp_inbox = NULL; $inboxfile = $exbb['home_path'].'messages/'.$id.'-msg.php';
		$hiuser = Get_File_Data($fp_inbox,$inboxfile);
        $hiuser[$pmid]['from'] = $from;
        $hiuser[$pmid]['title'] = $lang['You_Punned'];
        $hiuser[$pmid]['msg'] = $pm_main.'<br>'.$pm_message;
        $hiuser[$pmid]['status'] = false;
        save_opened_file($fp_inbox,$hiuser);
        unset($hiuser);
}  #   

function vivodim() {
		global $vars,$punneduser,$punish_data,$forum,$exbb,$lang;
        foreach ($punneduser['punned'] as $id=>$value){
        		list($in_f1,$in_t1,$in_k1,$in_m1,$pagestart) = explode('::',$id);
                foreach ($forum as $ids=>$name){
                		if($ids==$in_f1)$f_name= $name['name'];
                }
                $topics = get_file($exbb['home_path'].'forum'.$in_f1.'/list.php');
                foreach ($topics as $tid=>$tname){
                		if($tid==$in_t1)$t_name=$tname['name'];
                }
                list($names_pun,$st) = explode('::',$value);
                $status = ($st=='Ad') ? $lang['Pun_Admin']:$lang['Pun_Moder'];
                $kem = $status.' - '.$names_pun;
                include('./templates/'.$exbb['default_style'].'/modules/punish/punish_data.tpl');
        }
        unset($punneduser);
        return;
}
?>
