<?php
/****************************************************************************
* ExBB v.1.9                                                              	*
* Copyright (c) 2002-20 by Alexander Subhankulov aka Warlock            	*
*                                                                         	*
* http://www.exbb.net                                             			*
* email: admin@exbb.net                                           			*
*                                                                         	*
****************************************************************************/
/****************************************************************************
*                                                                         	*
*   This program is free software; you can redistribute it and/or modify  	*
*   it under the terms of the GNU General Public License as published by  	*
*   the Free Software Foundation; either version 2 of the License, or     	*
*   (at your option) any later version.                                   	*
*																			*
****************************************************************************/
define("IN_ADMIN", true);
include('common.php');
include('./data/boardstats.php');

$vars = parsed_vars();

switch ($vars['action']) {
	case 'addcat'		:
    case 'addforum'		: addforum();	 	break;
    case 'doaddcat'		:
    case 'processnew'	: createforum(); 	break;
	case 'edit'			: editform(); 		break;
    case 'doedit'		: doedit(); 		break;
    case 'editcatname'	: editcatname(); 	break;
    case 'reorder'		: reordercats(); 	break;
	case 'forum_order'	: reorderfrms(); 	break;
    case 'recount'		: recount(); 		break;
    case 'delcat'		:
    case 'delete'		: warning(); 		break;
    case 'dodelforum'	: deleteforum(); 	break;
    case 'dodelcat'		: deletecat(); 		break;
    case 'stat'			: statist(); 		break;
    case 'restore'		: restore(); 		break;
    default				: forumlist(); 		break;
}

include('page_tail_admin.php');

function addforum() {
		global $exbb,$vars,$lang;
		$incategory = $vars['category'];

		$forums = get_file($exbb['home_path'].'data/allforums.php',FALSE);
		# Find the category name from the number
		$high = 0;
		foreach ($forums as $id=>$forum) {
				if ($incategory == $forum['catid']) $category = $forum['catname'];
				if ($id > $high) $high = $id;
		}
		$high++;
		$lang['safe_mode_cat'] = sprintf($lang['safe_mode_cat'],$high);
		if (ini_get('safe_mode')) $safe_mode = '<p>'.$lang['safe_mode_cat'].'</p>';

		if ($vars['action'] == 'addcat') {
			$hidden = '<input type=hidden name="action" value="doaddcat">
						<input type=hidden name="category" value="'.$incategory.'">';
			$cathtml = '<input type=text size=40 name="categoryname" value="">';
			$do = $lang['New_forum_cat'];
		} else {
				$cathtml = categories($forums,$incategory);
				$hidden = '<input type=hidden name="action" value="processnew">';
				$do = $lang['New_forum'];
		}
		$codes_on = 'selected';
		$codes_off = '';
		$polls_on = 'checked="checked"';
		$polls_off = '';
		$private_on = '';
		$private_off = 'selected';
		$access_all = 'selected';
		$access_reged = '';
		$access_no = '';
		$upsize = '';
		$button = $lang['Forum_create'];

		include('./admin/all_header.tpl');
		include('./admin/nav_bar.tpl');
		include('./admin/addforum.tpl');
		include('./admin/footer.tpl');
} # end route

function createforum() {
		global $exbb,$vars,$lang;

		$catid = ($vars['action'] == 'doaddcat') ? $vars['category'] : $vars['tocat'];
		$catid = intval($catid);

		$fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
		$allforums = Get_File_Data($fp_allforums,$allforumsfile,FALSE);

		# Create a new number for the new forum folder, and files.
		$pos = array();
		$high = 0;
		foreach ($allforums as $id=>$forum) {
				if ($id > $high) $high = $id;
				if ($forum['catid'] == $catid) {$pos[] = $forum['position']; $cat_name = $forum['catname']; }
		}
		$catname = ($vars['action'] == 'doaddcat') ? $_POST['categoryname'] : $cat_name;

		$newforumid = $high + 1;
		$new_position = ($vars['action'] == 'doaddcat') ? intval($catid.'01') : max($pos) + 1;
		# Lets create the directory.
		$dirtomake = $exbb['home_path'].'forum'.$newforumid;

		if (!@ini_get('safe_mode')) {
			@mkdir($dirtomake,$exbb['ch_dirs']);
			@chmod($dirtomake,$exbb['ch_dirs']);
		} else {
       			if (!is_dir($dirtomake)) {
       				fclose($fp_allforums);
       				adminerror($lang['No_dir'],sprintf($lang['safe_mode_cat'],$newforumid),'',0);
       			}
		}

		# Lets add a file to stop snoops, and to use to see if the forum was created
		$htaccess = "AuthUserFile /dev/null\nAuthGroupFile /dev/null\nAuthName DenyViaWeb\nAuthType Basic\n\n\n\n<Limit GET>\norder allow,deny\ndeny from all\n</Limit>";
		$html = "<html><head><title>No access</title></head>\n<body>No access allowed</body></html>\n";
		New_File($dirtomake.'/.htaccess',$htaccess);
		New_File($dirtomake.'/index.html',$html);

		if (!empty($vars['forummoderator'])) {
			make_moderators();
		}

  		$allforums[$newforumid]['catname'] = $catname;
  		$allforums[$newforumid]['catid'] = $catid;
  		$allforums[$newforumid]['name'] = $_POST['forumname'];
  		$allforums[$newforumid]['desc'] = $_POST['forumdescription'];
  		$allforums[$newforumid]['posts'] = 0;
  		$allforums[$newforumid]['topics'] = 0;
  		$allforums[$newforumid]['position'] = $new_position;

  		$allforums[$newforumid]['status'] = $vars['startnewthreads'];
  		$allforums[$newforumid]['moderator'] = $vars['forummoderator'];;
  		$allforums[$newforumid]['private'] = ($vars['privateforum'] == 'no') ? false : true;
  		$allforums[$newforumid]['codes'] = ($vars['codestate'] == 'on') ? true : false;
  		$allforums[$newforumid]['polls'] = ($vars['polls'] == '1') ? true : false;
  		$allforums[$newforumid]['icon'] = $vars['forumgraphic'];

  		$vars['upsize'] = ($vars['upsize'] > 0) ? $vars['upsize'] = (int)$vars['upsize'] * 1024 : '';
  		if ($vars['upsize']) $allforums[$newforumid]['upload'] = $vars['upsize'];

  		uasort($allforums,'sort_by_catid');
  		uasort($allforums,'sort_by_position');
		save_opened_file($fp_allforums,$allforums);

        /* ////  For fix zeros bugs  //// */
        clearstatcache();
        send_bugs(__FILE__,__LINE__,array($allforumsfile),19);
        /* ////  For fix zeros bugs  //// */
  		adminerror($lang['Info'],$lang['Forum_created'],'',0);
}

function editform() {
		global $exbb,$vars,$lang;

		$inforum = $forumid = $vars['forum'];

		$allforums = get_file($exbb['home_path'].'data/allforums.php',FALSE);

		$cathtml = $allforums[$inforum]['catname'];
		$categoryplace = $allforums[$inforum]['catid'];

		$forummoderator = unserialize($allforums[$inforum]['moderator']);
		$forummoderator = array_values($forummoderator);
		$forummoderator = implode(',', $forummoderator);

		$forumgraphic = $allforums[$inforum]['icon'];

		$hidden = '<input type=hidden name="action" value="doedit">
					<input type=hidden name="forum" value="'.$inforum.'">';

		#$forumname = str_replace('&quot;','"',$allforums[$inforum]['name']);
		$forumname = stripslashes($allforums[$inforum]['name']);
		$forumdescription = htmlspecialchars(stripslashes($allforums[$inforum]['desc']),ENT_QUOTES);
		$do = $lang['Edit_forum'];

		$codes_on = ($allforums[$inforum]['codes']) ? 'selected' : '';
		$codes_off = (!$allforums[$inforum]['codes']) ? 'selected' : '';

		$polls_on = ($allforums[$inforum]['polls']) ? 'checked="checked"' : '';
		$polls_off = (!$allforums[$inforum]['polls']) ? 'checked="checked"' : '';

		$private_on = ($allforums[$inforum]['private']) ? 'selected' : '';
		$private_off = (!$allforums[$inforum]['private']) ? 'selected' : '';

		$access_all = ($allforums[$inforum]['status'] == 'all') ? 'selected' : '';
		$access_reged = ($allforums[$inforum]['status'] == 'reged') ? 'selected' : '';
		$access_no = ($allforums[$inforum]['status'] == 'no') ? 'selected' : '';

		$upsize = (isset($allforums[$inforum]['upload'])) ? $allforums[$inforum]['upload']/1024 : '';
		$button = $lang['Update'];

		include('./admin/all_header.tpl');
        include('./admin/nav_bar.tpl');
		include('./admin/addforum.tpl');
		include('./admin/footer.tpl');
}

function doedit() {
		global $exbb,$vars,$lang;

		$inforum = $vars['forum'];

		$fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
		$allforums = Get_File_Data($fp_allforums,$allforumsfile,FALSE);

		if (!isset($allforums[$inforum])) {
			fclose($fp_allforums);
			adminerror($lang['Info'],$lang['Forum_edit_adminerror'],'',0);
		}

		$backupfile = $exbb['home_path'].'data/allforums_bak.php';
		@copy($allforumsfile,$backupfile);
		@chmod($backupfile,$exbb['ch_files']);

		if (!empty($vars['forummoderator'])) make_moderators();

		$allforums[$inforum]['name'] = $_POST['forumname'];;
		$allforums[$inforum]['desc'] = $_POST['forumdescription'];
		$allforums[$inforum]['moderator'] = $vars['forummoderator'];
		$allforums[$inforum]['codes'] = ($vars['codestate'] == 'on') ? true : false;
		$allforums[$inforum]['polls'] = ($vars['polls'] == '1') ? true : false;
		$allforums[$inforum]['private'] = ($vars['privateforum'] == 'yes') ? true : false;
		$allforums[$inforum]['status'] = $vars['startnewthreads'];

		if (!empty($vars['forumgraphic'])) {
			$vars['forumgraphic'] = trim($vars['forumgraphic']);
			if (file_exists($exbb['home_path'].'im/images/'.$vars['forumgraphic'])) {
				$allforums[$inforum]['icon'] = $vars['forumgraphic'];
			} else {
					unset($allforums[$inforum]['icon']);
			}
		} else {
				unset($allforums[$inforum]['icon']);
		}

		$vars['upsize'] = ($vars['upsize'] > 0) ? (int)$vars['upsize'] * 1024 : '';
		if ($vars['upsize']) {$allforums[$inforum]['upload'] = $vars['upsize'];}
		else {unset($allforums[$inforum]['upload']);}

		save_opened_file($fp_allforums,$allforums);
        /* ////  For fix zeros bugs  //// */
        clearstatcache();
        send_bugs(__FILE__,__LINE__,array($allforumsfile),20);
        /* ////  For fix zeros bugs  //// */
		adminerror($lang['Info'],$lang['Forum_edit_ok'],'',0);
}

function editcatname() {
		global $exbb,$vars,$lang;

		$fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
		$allforums = Get_File_Data($fp_allforums,$allforumsfile,FALSE);

		if (!isset($vars['doedit'])) {
            fclose($fp_allforums);
			$incategory = $vars['category'];
			foreach ($allforums as $id=>$forum) {
					if ($incategory == $forum['catid']) {
						$categoryname = $forum['catname'];
					}
			}
			include('./admin/all_header.tpl');
            include('./admin/nav_bar.tpl');
            include('./admin/nav_bar.tpl');
			include('./admin/edit_catname.tpl');
		} else {
				$incategory = $vars['category'];
                foreach ($allforums as $id=>$forum){
           			if ($incategory == $forum['catid']) $allforums[$id]['catname'] = $_POST['categoryname'];
        		}
        		save_opened_file($fp_allforums,$allforums);
        		/* ////  For fix zeros bugs  //// */
        		clearstatcache();
        		send_bugs(__FILE__,__LINE__,array($allforumsfile),21);
        		/* ////  For fix zeros bugs  //// */
        		adminerror($lang['Info'],$lang['New_catname_ok'],'',0);
  		}
}

function reordercats() {
		global $exbb,$vars;

		$incategory = intval($vars['category']);
		$tomove = intval($vars['move']);

		if ($incategory == 1 && $tomove == -1) {
			Header('Location: setforums.php');
			exit;
		}

		$fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
		$allforums = Get_File_Data($fp_allforums,$allforumsfile,FALSE);
		$categories = array();
		foreach ($allforums as $id=>$forum) {
				if ($lastid != $forum['catid']) $categories[] = $forum['catid'];
				$lastid = $forum['catid'];
		}

		if (count($categories) == 1) {
			fclose($fp_allforums);
			Header('Location: setforums.php');
			exit;
		}
		if ($incategory == count($categories) && $tomove == 1) {
			fclose($fp_allforums);
			Header('Location: setforums.php');
			exit;
		}

		$newcatid = ($tomove == 1) ? $incategory + 1 : $incategory - 1;

		if (isset($newcatid)) {
			$newallforums = array();
			$inpos = 0;
			$newpos = 0;
			foreach ($allforums as $id=>$forum) {
					if ($forum['catid'] == $incategory) {
            			$newallforums[$id] = $forum;
            			$newallforums[$id]['catid'] = $newcatid;
						$inpos++;
						if ($inpos < 10) {
							$newallforums[$id]['position'] = intval($newcatid.'0'.$inpos);
						} else {
								$newallforums[$id]['position'] = intval($newcatid.$inpos);
						}
         			} elseif ($forum['catid'] == $newcatid) {
							$newallforums[$id] = $forum;
							$newallforums[$id]['catid'] = $incategory;
							$newpos++;
							if ($newpos < 10) {
								$newallforums[$id]['position'] = intval($incategory.'0'.$newpos);
							} else {
									$newallforums[$id]['position'] = intval($incategory.$newpos);
							}
					} else {
							$newallforums[$id] = $forum;
					}
			}
			uasort($newallforums,'sort_by_position');
			save_opened_file($fp_allforums,$newallforums);
		} else {
				fclose($fp_allforums);
		}
        /* ////  For fix zeros bugs  //// */
        clearstatcache();
        send_bugs(__FILE__,__LINE__,array($allforumsfile),22);
        /* ////  For fix zeros bugs  //// */
  		Header('Location: setforums.php'); exit;
}

function reorderfrms() {
		global $exbb,$vars,$lang;

		$inforum = $vars['forum'];
		$incategory = intval($vars['category']);
		$tomove = intval($vars['move']);

		$fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
		$allforums = Get_File_Data($fp_allforums,$allforumsfile,FALSE);

  		$allforums = make_positions($allforums);

  		$pos = array();
		foreach ($allforums as $id=>$forum) {
				if ($incategory == $forum['catid']) {
					$pos[$id] = $forum['position'];
					$lastid = $id;
				}
		}
		$ids = array_keys($pos);
		if ($tomove == -1 && $allforums[$inforum]['position'] == $pos[$ids[0]]) {fclose($all); Header('Location: setforums.php'); exit;}
		if ($tomove == 1 && $allforums[$inforum]['position'] == $pos[$lastid]) {fclose($all); Header('Location: setforums.php'); exit;}

		$oldpos = $allforums[$inforum]['position'];
		if ($tomove == 1) {$newpos = $oldpos + 1;}
		if ($tomove == -1) {$newpos = $oldpos - 1;}

  		foreach ($pos as $inf=>$pstion) {
				if ($pstion == $newpos) {$in = $inf; break;}
		}
  		if (isset($in) && isset($newpos)) {
			$allforums[$inforum]['position'] = intval($newpos);
			$allforums[$in]['position'] = intval($oldpos);
			uasort($allforums,'sort_by_position');
			save_opened_file($fp_allforums,$allforums);
		} else {
				fclose($fp_allforums);
		}
        /* ////  For fix zeros bugs  //// */
        clearstatcache();
        send_bugs(__FILE__,__LINE__,array($allforumsfile),23);
        /* ////  For fix zeros bugs  //// */
  		Header('Location: setforums.php'); exit;
}

function recount() { #start
		global $exbb,$vars,$lang;

		$inforum = $vars['forum'];
		$topics = array();
		$postscount = 0;
        $topiccount = 0;
        $topics = get_file($exbb['home_path'].'forum'.$inforum.'/list.php',FALSE);

		if (is_array($topics) && count($topics) > 0) {
            $topiccount = count($topics);
			foreach ($topics as $id=>$topic) $postscount += $topic['posts'];
		}
		$fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
		$allforums = Get_File_Data($fp_allforums,$allforumsfile,FALSE);
		$allforums[$inforum]['topics'] = $topiccount;
		$allforums[$inforum]['posts'] = $postscount;
        save_opened_file($fp_allforums,$allforums);
        /* ////  For fix zeros bugs  //// */
        clearstatcache();
        send_bugs(__FILE__,__LINE__,array($allforumsfile),24);
        /* ////  For fix zeros bugs  //// */
		$info = $lang['Topics_total'].' '.$topiccount.'<br>'.$lang['Posts_total'].' '.$postscount;
		adminerror($lang['Counting_complete'],$info,'',0);
}

function warning() {
		global $exbb,$vars,$lang;

		$inforum = (isset($vars['forum'])) ? $vars['forum'] : $vars['category'];
		$delete = ($vars['action'] == 'delete') ? 'dodelforum' : 'dodelcat';
		include('./admin/all_header.tpl');
        include('./admin/nav_bar.tpl');
		include('./admin/del_forum.tpl');
		include('./admin/footer.tpl');
}

function deleteforum($what = '') {
		global $exbb,$vars,$lang;

		$inforum = (empty($what)) ? $vars['forum'] : $what;
		$dirtoremove = $exbb['home_path'].'forum'.$inforum;
		$dirdata = array();
		if (is_dir($dirtoremove)) {
        	if (!($dirdata = get_dir($dirtoremove,'{*,*.*,.h*}',GLOB_BRACE))) {
				$handle=opendir($dirtoremove);
				while (false !== ($file = readdir($handle))) {
					if (($file != '.') and ($file != '..')) {$dirdata[]=$file;}
                }
                closedir($handle);
			}

			foreach ($dirdata as $file) @unlink($dirtoremove.'/'.$file);

			if (!ini_get('safe_mode')) {
				@rmdir($dirtoremove);
			} else {
					$needremove = '<br>'.sprintf($lang['Must_remove'],$inforum);
			}

			$fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
			$allforums = Get_File_Data($fp_allforums,$allforumsfile,FALSE);

			$exbb['totalposts'] -= $allforums[$inforum]['posts'];
			$exbb['totalthreads'] -= $allforums[$inforum]['topics'];
			save_statfile();

			unset($allforums[$inforum]);
			save_opened_file($fp_allforums,$allforums);
		}
        /* ////  For fix zeros bugs  //// */
        clearstatcache();
        send_bugs(__FILE__,__LINE__,array($allforumsfile),25);
        /* ////  For fix zeros bugs  //// */
		if (empty($what)) {
			adminerror($lang['Info'],$lang['Forums_updated'].$needremove,'',0);
		} else {
				return $needremove;
		}
}

function deletecat() {
		global $exbb,$vars,$lang;

		$incategory = $vars['forum'];

		$allforums = get_file($exbb['home_path'].'data/allforums.php',FALSE);
		$todelete = array();
		foreach ($allforums as $id=>$forum) {
				if ($forum['catid'] == $incategory) $todelete[] = $id;
		}
  		$needremove = '';
  		if (count($todelete) > 0) {
			foreach($todelete as $forum) $needremove .= deleteforum($forum);
		} else {
				adminerror($lang['EXBB_adminerror'],$lang['Cat_del_adminerror'],'',0);
		}
		adminerror($lang['Info'],$lang['Forums_updated'].$needremove,'',0);
}

function statist() {
		global $exbb,$vars,$lang;

		$allforums = get_file($exbb['home_path'].'data/allforums.php',FALSE);

		if (is_array($allforums)) {
			$totalposts = 0;
			$totalthreads = 0;

			foreach ($allforums as $id=>$forum) {
					$totalposts += $forum['posts'];
					$totalthreads += $forum['topics'];
			}
			$info = "$lang[Now_stat]<br>$lang[Posts_total] <b>$exbb[totalposts]</b><br>$lang[Topics_total]: <b>$exbb[totalthreads]</b><p>$lang[After_recount]<br>
					$lang[Posts_total] <b>$totalposts</b><br>$lang[Topics_total] <b>$totalthreads</b>";
			$exbb['totalposts'] = $totalposts;
			$exbb['totalthreads'] = $totalthreads;
			save_statfile();

			adminerror($lang['Info'],$info,'',0);

		} else {
				adminerror($lang['Info'],$lang['Stat_adminerror'],'',0);
		}
}

function restore(){
		global $exbb,$vars,$lang;

		$inforum = $vars['forum'];
		$forum_dir = $exbb['home_path'].'forum'.$inforum.'/';
		if(!is_dir($forum_dir)) {
			adminerror($lang['System_error'],$lang['Wrong_forum_dir'].$dirtoopen);
		}
		$views_data  = get_file($exbb['home_path'].'forum'.$inforum.'/views.php',FALSE);
		unlink($forum_dir.'list.php');

		$dir = dir($forum_dir);
		$file_array = array();
		while (false !== ($file = $dir->read())) {
			if (strstr($file,'-thd.php')){
				$intopic = substr($file, 0, -8);
				$topic_data = get_file($forum_dir.'/'.$intopic.'-thd.php',FALSE);
				$keys = array_keys($topic_data);
				sort($keys,SORT_NUMERIC);
				$topic_date = reset($keys);
                //    
				$topic_posts  = count($topic_data) - 1;
				$topic_name   = $topic_data[$topic_date]['name'];
				$topic_desc   = (isset($topic_data[$topic_date]['desc'])) ?$topic_data[$topic_date]['desc']:'';
				$topic_state  = (isset($topic_data[$topic_date]['state'])) ?$topic_data[$topic_date]['state']:'open';
				$topic_a_id   = $topic_data[$topic_date]['p_id'];
				$topic_author = ($topic_a_id != 0) ? Member_Name($topic_a_id):'';
                $topic_views  = (isset($views_data[$intopic])) ? $views_data[$intopic]:0;

				$topic_extmode = array();
				$topic_extmode[0] = $topic_posts;
				$topic_fls = 1;
				$file = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd';
				while (file_exists($file.$topic_fls.'.php')){
					$newtop = get_file($file.$topic_fls.'.php',FALSE);
					$topic_posts = $topic_posts + count($newtop);
					$topic_extmode[$topic_fls] = count($newtop);
					$topic_fls++;
				}
				$topic_fls--;

				if ($topic_fls > 0 ){
					$topic_fls_file = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$topic_fls.'.php';
					$topic_fls_data = get_file($topic_fls_file,FALSE);
					ksort($topic_fls_data,SORT_NUMERIC);
					end($topic_fls_data);
					$topic_postdate = key($topic_fls_data);
					$topic_p_id = $topic_fls_data[$topic_postdate]['p_id'];
				} else {
						end($topic_data);
						$topic_postdate = key($topic_data);
						$topic_p_id = $topic_data[$topic_postdate]['p_id'];
				}

				$topic_poster = ($topic_p_id != 0) ? Member_Name($topic_p_id):'';
				//   
				$list[$intopic]['name']     = $topic_name;
				$list[$intopic]['id']     	= $intopic;
				$list[$intopic]['fid']     	= $inforum;
				if(!empty($topic_desc)){$list[$intopic]['desc'] = $topic_desc;}
				$list[$intopic]['state']    = $topic_state;
				$list[$intopic]['posts']    = $topic_posts;
				$list[$intopic]['author']   = $topic_author;
				$list[$intopic]['a_id']     = $topic_a_id;
				$list[$intopic]['date']     = $topic_date;
				$list[$intopic]['poster']   = $topic_poster;
				$list[$intopic]['p_id']     = $topic_p_id;
				$list[$intopic]['postdate'] = $topic_postdate;
				$list[$intopic]['views']    = $topic_views;
				if ($topic_fls > 0){
					$list[$intopic]['ext'] = serialize($topic_extmode);
					$list[$intopic]['fls'] = $topic_fls;
				}
				if($topic_state == 'moved'){$list[$intopic]['movedid'] = $topic_data[$topic_date]['movedid'];}
				if(TRUE === isset_poll($inforum,$intopic)){ $list[$intopic]['poll'] = true; }
			}
		}
		$dir->close();
		uasort ($list, 'sort_by_postdate');
		$list_file = $exbb['home_path'].'forum'.$inforum.'/list.php';
		save_file($list_file,$list);
		@chmod($list_file,$exbb['ch_files']);
		$restored  = count($list);
		unset($list,$views_data,$member_data,$topic_data);

		$mess = ( $restored ) ? sprintf($lang['List_forum_ok'],$restored) : $lang['List_forum_done'];
		adminerror($lang['List_forum_dir'],$mess,'<meta http-equiv="refresh" content="3; url=setforums.php">',false);
}

function forumlist() {
		global $exbb,$lang,$modoutput,$lang_moder;

		$highest = 0;
        $forum_data = "";
		if (ini_get('safe_mode')) $safe_mode = '<p>'.$lang['safe_mode_on'].'</p>';

        $forums = get_file($exbb['home_path'].'data/allforums.php',FALSE);
		if (is_array($forums)) {
            $lastcategoryplace = -1;
			foreach ($forums as $forumid=>$forum) {
					moderator($forumid,$forums);
					$catrow = ($forum['catid'] != $lastcategoryplace) ? true : false;
					$private = ( $forum['private'] ) ? $lang['Private'] : '';
					$forum['name'] = stripslashes($forum['name']);
					$forum['desc'] = stripslashes($forum['desc']);
					include('./admin/forumlist_data.tpl');
					$lastcategoryplace = $forum['catid'];
					if ($forum['catid'] > $highest) { $highest = $forum['catid']; }
			}
		}

  		$highest++;
  		include('./admin/all_header.tpl');
        include('./admin/nav_bar.tpl');
  		include('./admin/forumlist.tpl');
  		include('./admin/footer.tpl');
}

function categories($allfrm,$in) {
		$cathtml = '<select name="tocat">';
		$cates = array();
		foreach($allfrm as $forumid=>$val) $cates[$val['catid']] = $val['catname'];
		foreach($cates as $id=>$name) if ($id == $in) {$cathtml .= '<option value="'.$id.'" selected>'.$name."\n";} else {$cathtml .= '<option value="'.$id.'">'.$name."\n";}
		$cathtml .= '</select>';
		return $cathtml;
}

function make_moderators() {
		global $exbb,$vars,$lang;

    	$moderators = str_replace(', ',',',$vars['forummoderator']);
    	$moderators = str_replace(' ,',',',$moderators);
    	$moders = $moderators;
    	$moderators = preg_replace ($lang['search'], $lang['replace'], $moderators);
    	$moderators = explode(',',$moderators);
    	$moders = explode(',',$moders);
    	$allusers = get_file($exbb['home_path'].'data/users.php',FALSE);
    	$mod_id = array();
    	$count = count($moderators);
    	$i = 0;
		foreach ($allusers as $id=>$info) {
				foreach ($moderators as $pos=>$name) {
					if ($info['n'] == $name ) {
						$mod_id[$id] = $moders[$pos];
						$i++; break;
					}
       			}
       			if ($i == $count) break;
    	}
    	$vars['forummoderator'] = serialize($mod_id);
    	unset($moderators,$allusers,$mod_id,$count,$i,$moders);
		return;
}

function make_positions($all) {
		$pos = array();
		foreach ($all as $id => $data) {
				$lastid = $id;
				if ( !isset($pos[$data['catid']]) ) { $pos[$data['catid']] = $data['catid'] * 100 + 1; }
				$all{$id}['position'] = $pos[$data['catid']]++;
		}
        uasort($all,'sort_by_position');
        return $all;
}

function Member_Name($id) {
		global $exbb;
        $member_data = getmember($id);
        if($member_data !== FALSE) {
               $name = $member_data['name'];
               unset($member_data);
               return $name;
        } else {
        		return '';
        }
}

function New_File($filename,$somecontent){
		$handle = fopen($filename, 'w');
        fwrite($handle, $somecontent);
        fclose($handle);
        chmod($filename,0644);
}
?>
