<?php
/****************************************************************************
* ExBB v.1.9                                                              	*
* Copyright (c) 2002-20 by Alexander Subhankulov aka Warlock            	*
*                                                                         	*
* http://www.exbb.net                                             			*
* email: admin@exbb.net                                           			*
*                                                                         	*
****************************************************************************/
/****************************************************************************
*                                                                         	*
*   This program is free software; you can redistribute it and/or modify  	*
*   it under the terms of the GNU General Public License as published by  	*
*   the Free Software Foundation; either version 2 of the License, or     	*
*   (at your option) any later version.                                   	*
*                                                                         	*
****************************************************************************/
define('IN_ADMIN', true);

include('common.php');
include('./data/boardstats.php');

$vars = parsed_vars();

switch ($vars['action']) {
		case 'updatecount'	: docount(); break;
     	case 'edit_user'	: edit(); break;
     	case 'log'			: logfile(); break;
     	case 'massmail'		: mass_mail(); break;
     	default				: memberoptions(); break;
}

function docount() {
		global $exbb,$lang;

   		$filedata = array();
   		$dirtoread = $exbb['home_path'].'members';
   		@set_time_limit(60);

        $d = dir($dirtoread);
		while (false !== ($file = $d->read())) {
        	if (preg_match("#^[0-9]+\.php$#is",$file)){
                if (filesize($dirtoread.'/'.$file) <= 100) {
                    unlink($dirtoread.'/'.$file);
                } else {
						$filedata[] = $file;
				}
            }
        }
        $d->close();

        $users = array();
		$users_posts = array();
        foreach ($filedata as $id => $user) {
        		$uid = substr($user,0,-4);
         		$userinfo = getmember($uid);
                if ($userinfo) {
                    $users[$userinfo['id']]['n'] = preg_replace ($lang['search'], $lang['replace'], $userinfo['name']);
       				$users[$userinfo['id']]['m'] = $userinfo['mail'];
       				$users_posts[$userinfo['id']] = $userinfo['posts'];
     			} else {
     					continue;
     			}
   		}
        save_file($exbb['home_path'].'data/users.php',$users);
   		save_file($exbb['home_path'].'data/users_posts.php',$users_posts);
   		$total = count($users);

   		unset($filedata,$userinfo,$users);
   		$exbb['totalmembers'] = $total;
   		save_statfile();

   		adminerror($lang['User_count_upd'],$lang['User_count'].$total,'',0);
}

function edit() {
		global $exbb,$vars,$lang;

        $user_id = $vars['userid'];

        $user = array();
        $fp_user = NULL; $userfile = $exbb['home_path'].'members/'.$user_id.'.php';
        $user = Get_File_Data($fp_user,$userfile,FALSE);

        if ($vars['checkaction'] == 'yes') {
			if ($_SERVER['REQUEST_METHOD'] !=='POST'){adminerror($lang['Main_msg'],$lang['Correct_post'],'',0);}

			if (isset($vars['deleteuser'])) {deletemember();}
            $vars['newname'] = str_replace( "'" , '&#39;', $vars['newname'] );

            $newname = ($user['name'] == $vars['newname'] || empty($vars['newname'])) ? false : true;

            $newpassword = (!empty($vars['password'])) ? $vars['password'] : '';
            if (!empty($newpassword)) $user['pass'] = md5($newpassword);
            $laststatus = $user['status'];

            $user['name']     = ($newname) ? $vars['newname'] : $user['name'];
            $user['title']    = $_POST['membertitle'];
            $user['www']      = $vars['homepage'];
            $user['aim']      = $vars['aolname'];
            $user['icq']      = $vars['icqnumber'];
            $user['location'] = $_POST['location'];
            $user['interests']= $_POST['interests'];
            $user['sig'] =      soft_clr_value($_POST['signature']);
            $user['posts']    = intval($vars['numberofposts']);
            $user['timedif']  = (!empty($vars['timedif'])) ? $vars['timedif'] : 0;
            $user['status']   = $vars['membercode'];
            $user['avatar']   = $vars['avatar'];
            $user['upload'] = (isset($vars['doupload'])) ? true : false;

            $forums = get_file($exbb['home_path'].'data/allforums.php',FALSE);

            foreach ($forums as $id=>$infa) {
            		if ($infa['private']) {
                    	$namekey = 'allow'.$id;
                        $tocheck = ( isset($vars[$namekey]) ) ? $vars[$namekey] : 'no';
                        $user['private'][$id] = ($tocheck == 'yes') ? true : false;
                    }
            }

            # Add to ban lists (if required)
            if ($laststatus == 'banned' && $user['status'] != 'banned') { unban($user_id); }
            if ($user['status'] == 'banned') {
            	$filetoopen = $exbb['home_path'].'data/banlist.php';
                $banlist = get_file($filetoopen);
                if (!is_array($banlist)) $banlist = array();
                $banlist[$user_id]['m'] = $user['mail'];
                $banlist[$user_id]['ip'] = $user['ip'];
               	save_file($filetoopen,$banlist);
                unset($banlist);
            }

            $newemail =($user['mail'] != strtolower($vars['emailaddress']))? TRUE:FALSE;
            $user['mail']     = strtolower($vars['emailaddress']);
            save_opened_file($fp_user,$user);

            if ($newname || $newemail) {
            	$fp_allusers = NULL; $allusersfile = $exbb['home_path'].'data/users.php';
        		$allusers = Get_File_Data($fp_allusers,$allusersfile,FALSE);
                $allusers[$user_id]['n'] = preg_replace ($lang['search'], $lang['replace'], $user['name']);
                $allusers[$user_id]['m'] = $user['mail'];
                save_opened_file($fp_allusers,$allusers);
                unset($allusers);
            }

            if (!empty($newpassword) || $newname || $newemail) {
            	$time = date("d-m-Y H:i:s",time());
                $username = str_replace( '&#39;', "'" , $user['name'] );
                $username = str_replace( '&quot;', "\"" , $user['name'] );
                include('./admin/email_newpass.tpl');
                sendmail($exbb['boardname'],$exbb['adminemail'],$email,$lang['Notify_by_email'],$user['mail']);
            }
            /* ////  For fix zeros bugs  //// */
            clearstatcache();
            send_bugs(__FILE__,__LINE__,array($allusersfile,$userfile),26);
            /* ////  For fix zeros bugs  //// */
            adminerror($lang['Info'],$lang['Updated_ok'],'',0);
        } else {
        		fclose($fp_user);
        		include($exbb['home_path'] . 'language/' . $exbb['default_lang'] . '/lang_reg.php');
                $privateoutput = '';
                $forums = get_file($exbb['home_path']."data/allforums.php",FALSE);
                foreach ($forums as $id=>$infa) {
                		if ($infa['private']) {
                        	$checked = $user['private'][$id] ? 'checked' : '';
                            $privateoutput .= '<input type="checkbox" name="allow'.$id.'" value="yes" '.$checked.'>'.$infa['name'].'<br>';
                        }
                }
                if (empty($privateoutput)) $privateoutput = $lang['No_private_forums'];
                #XXXXXXXXXXXXXXXXXX   XXXXXXXXXXXXXXXXXXXXXXXXXXX
                $admin_birsday = NULL;
                if ($exbb['birstday'] == TRUE){
                	include ($exbb['home_path'].'modules/birstday/setmembers.php');
  				}
                #XXXXXXXXXXXXXXXXXX   XXXXXXXXXXXXXXXXXXXXXXXXXXX
                $user['sig'] = str_replace('<br>',"\n",$user['sig']);
                $checked = ($user['upload']) ? 'checked' : '';
                $lastvisitdate 	= longDate($user['last_visit']);
                $regdate 		= longDate($user['joined']);
                $dataout = "<select name=\"membercode\">
                				<option value=\"me\">".$lang['User']."</option>
                				<option value=\"banned\">".$lang['Banned_user']."</option>
                				<option value=\"ad\">".$lang['Admin']."</option>
                		   </select>";
                $dataout = str_replace("value=\"$user[status]\"","value=\"$user[status]\" selected",$dataout);

                include('./admin/all_header.tpl');
                include('./admin/nav_bar.tpl');
                include('./admin/edit_user.tpl');
                include('./admin/footer.tpl');
                include('page_tail_admin.php');
		} # end else
} # endroute

function logfile() {
		global $exbb,$lang,$vars;
		$access_logfile = $exbb['home_path'].'data/access_log.php';
  		if (isset($vars['m'])) {
    		$fp = fopen($access_logfile,'w');
        	lock_file($fp,$access_logfile,LOCK_EX);
    		fwrite($fp,'<?die;?>'."\n");
    		fclose($fp);
  		}
  		$log = file($access_logfile);
  		unset($log[0]);
  		$log = @array_reverse($log);
  		$log = $exbb['log'] ? implode("",$log) : $lang['Forum_log_off'].implode("",$log);
  		include('./admin/all_header.tpl');
        include('./admin/nav_bar.tpl');
  		include('./admin/logfile.tpl');
  		include('./admin/footer.tpl');
  		include('page_tail_admin.php');
		return;
}

function mass_mail() {
        global $exbb,$lang,$vars;

        if (isset($vars['mode'])) {
        	$users = get_file($exbb['home_path'].'data/users.php',FALSE);
            if (is_array($users) && sizeof($users) > 0) {
            	$message = $lang['From_admin'].$exbb['boardname'].' ('.$exbb['boardurl'].")\n\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n".stripslashes(trim($_POST['message']));
                $bcc_list = array();
                foreach($users as $id=>$info) $bcc_list[$id] = 1;
                sendmail($exbb['boardname'],$exbb['adminemail'],$message,$vars['subject'],$bcc_list);
                unset($users,$bcc_list);
            } else {
            		adminerror($lang['Info'],$lang['Email_adminerror'],'',0);
            }
            adminerror($lang['Info'],$lang['Message_sent'],'',0);
		} else {
        		$script = 'setmembers.php';
                include('./admin/all_header.tpl');
                include('./admin/nav_bar.tpl');
                include('./admin/mass_mail.tpl');
                include('./admin/footer.tpl');
                include('page_tail_admin.php');
        }
}

function memberoptions() {
		global $exbb,$vars,$lang;

		if (empty($vars['action'])) {
       		$inputfields = '<input type="text" name="username" maxlength="50" size="20" />
        					<input type="hidden" name="action" value="find" />
        					<input type="submit" name="usersubmit" value="'.$lang['Find_user'].'"/>';
   		} else {
     			$users = get_file($exbb['home_path'].'data/users.php',FALSE);
     			$data = '';
     			$user = preg_replace ($lang['search'], $lang['replace'], $vars['username']);
         		$user = str_replace( "'" , '&#39;', $user);
     			foreach ($users as $id=>$info) {
       					if ( strstr($info['n'],$user) ) $data .= '<option value="'.$id.'">'.$info['n'].'</option>';
     			}
     			if (empty($data)) adminerror($lang['User_admin'],$lang['User_notfound'],'',0);
				$inputfields = <<<DATA
<select name='userid'>$data</select>
<input type="hidden" name="action" value="edit_user" />
<input type="submit" name="usersubmit" value="$lang[Sel_user]"/>
DATA;
		}

    	include('./admin/all_header.tpl');
        include('./admin/nav_bar.tpl');
    	include('./admin/user_select.tpl');
    	include('./admin/footer.tpl');
    	include('page_tail_admin.php');
}

function deletemember() {
		global $exbb,$vars,$lang;

    	$deleteduserfile = $exbb['home_path'].'members/'.$vars['userid'].'.php';

    	if (@unlink($deleteduserfile)) {
            # Delete the database for the member
            $fp_allusers = NULL; $allusersfile = $exbb['home_path'].'data/users.php';
        	$allusers = Get_File_Data($fp_allusers,$allusersfile,FALSE);
            unset($allusers[$vars['userid']]);
            save_opened_file($fp_allusers,$allusers);
      		$exbb['totalmembers']--;
      		save_statfile();
            /* ////  For fix zeros bugs  //// */
            clearstatcache();
            send_bugs(__FILE__,__LINE__,array($allusersfile),27);
            /* ////  For fix zeros bugs  //// */
      		adminerror($lang['Info'],$lang['User_deleted'],'',0);
    	} else {
    			adminerror($lang['Info'],$lang['User_notdeleted'],'',0);
    	}
} # end routine

function unban($user) {
		global $exbb;

 		# Remove from ban lists
 		$filetoopen = $exbb['home_path'].'data/banlist.php';
 		$banlist = get_file($filetoopen);
 		unset($banlist[$user]);
 		save_file($filetoopen,$banlist);
 		unset($filetoopen,$banlist);
}
?>
