<?php
/****************************************************************************
* ExBB v.1.1                                                              	*
* Copyright (c) 2002-20 by Alexander Subhankulov aka Warlock            	*
*                                                                         	*
* http://www.exbb.net                                             			*
* email: admin@exbb.net                                           			*
*                                                                         	*
****************************************************************************/
/****************************************************************************
*                                                                         	*
*   This program is free software; you can redistribute it and/or modify  	*
*   it under the terms of the GNU General Public License as published by  	*
*   the Free Software Foundation; either version 2 of the License, or     	*
*   (at your option) any later version.                                   	*
*                                                                         	*
****************************************************************************/
define("IS_LOGIN", true);

include('common.php');

$vars = parsed_vars();
if ($vars['action'] == 'login' and $_SERVER['QUERY_STRING'] == '' and  $vars['request_method'] == 'post') {
    $logeduser = FALSE;
    $id = precheck_user();
    if ($id !== 0) {
    	$fp_user = NULL; $userfile = $exbb['home_path'].'members/'.$id.'.php';
    	$logeduser = Get_File_Data($fp_user,$userfile,FALSE);
	}

    if (is_array($logeduser) and $logeduser['pass'] == md5($inpassword)) {
		access_log($logeduser['name']);
        if ($logeduser['status'] == 'banned') {
            fclose($fp_user);
        	error($lang['Error_login'],$lang['Login_dinied']);
        }
        $now_time = time();

      	$_SESSION['mid']			= intval($logeduser['id']);
      	$_SESSION['sts']			= $logeduser['status'];
      	$_SESSION['us_time']		= intval($logeduser['timedif']);
      	$_SESSION['lastposttime']	= isset($logeduser['lastpost']['date']) ? $logeduser['lastpost']['date'] : $now_time-180;
      	$_SESSION['last_visit'] 	= isset($logeduser['last_visit']) ? $logeduser['last_visit'] : $now_time;
      	$_SESSION['iden']			= md5($logeduser['name'].$logeduser['pass'].$exbb['sesid']);

      	$logeduser['last_visit'] = $now_time;
        save_opened_file($fp_user,$logeduser);

      	my_setcookie('exbbn',$logeduser['id']);
      	my_setcookie('exbbp',md5($logeduser['pass']));
      	my_setcookie('lastvisit',$now_time);
      	header('Location: index.php?'.session_name().'='.session_id()); exit;
    }

    access_log($vars['imembername'].' :: '.$vars['ipassword']);
    error($lang['Error_login'],$lang['Login_error'],'<meta http-equiv="refresh" content="3; url=loginout.php">');

} elseif ($vars['action'] == 'logout') {
		$_SESSION = array();
    	session_destroy();
    	my_setcookie('exbbn','',-1);
    	my_setcookie('exbbp','',-1);
    	my_setcookie('t_visits','',-1);
    	error($lang['Logout'],$lang['Close_browser'],'<meta http-equiv="refresh" content="3; url=index.php">',false);
} elseif ($vars['action'] == 'loginadminin' && $exbb['reged'] === true) {
		if ($vars['request_method'] == 'post') {
            $logged = getmember(precheck_user());
            if (is_array($logged) and $logged['pass'] === md5($inpassword) and $logged["status"] === "ad") {
            	$_SESSION['admin'] = true;
            	$_SESSION['admin_lasttime'] = time();
            	header('Location: admincenter.php'); exit;
            } else {
                	header('Location: index.php'); exit;
            }
        } else {
                $lang['Administrating'] = "ExBB Administration";
				include('./admin/all_header.tpl');
                include('./admin/loginform.tpl');
				include('page_tail_admin.php');
        }
}  else {
   		if ($exbb['reged'] === true) {
    		header('Location: index.php'); exit;
		}
		$title_page = $exbb['boardname'].' :: '.$lang['Login_out'];
		include('./templates/'.$exbb['default_style'].'all_header.tpl');
		include('./templates/'.$exbb['default_style'].'logos.tpl');
		include('./templates/'.$exbb['default_style'].'login.tpl');
		include('./templates/'.$exbb['default_style'].'footer.tpl');
}
include('page_tail.php');

function precheck_user() {
    	global $vars,$exbb,$lang,$inmembername,$inpassword;
    	$inmembername = (isset($vars['imembername'])) ? $vars['imembername'] : $exbb['member'];
    	$inpassword = (isset($vars['ipassword'])) ? $vars['ipassword'] : '';

    	$inmembername = substr($inmembername,0,32);
    	$inmembername = str_replace( "'" , '&#39;', $inmembername );
    	$inmembername = str_replace( "\\" , '', $inmembername );
    	$inmembername = str_replace( "/" , '', $inmembername );
    	$inmembername = preg_replace ($lang['search'], $lang['replace'], $inmembername);

    	$inpassword = substr($inpassword,0,32);

    	$allusers = get_file($exbb['home_path'].'data/users.php',FALSE);

    	$user_id = 0;
    	foreach ($allusers as $u_id=>$info) {
        		if ($inmembername == $info['n']) {
        			$user_id = $u_id;
        			break;
        		}
    	}
    	return $user_id;
}
?>
