<?php
/****************************************************************************
* ExBB v.1.1                                                              	*
* Copyright (c) 2002-20 by Alexander Subhankulov aka Warlock            	*
*                                                                         	*
* http://www.exbb.revansh.com                                             	*
* email: admin@exbb.revansh.com                                           	*
*                                                                         	*
* Modified in the PM Box Comfort v.1.1 by Mutalov Alisher aka Markus     	*
*                                                                         	*
* http://www.tvoyweb.ru                                                   	*
* http://www.tvoyweb.ru/forums                                            	*
* email: admin@tvoyweb.ru                                                 	*
****************************************************************************/
/****************************************************************************
*                                                                         	*
*   This program is free software; you can redistribute it and/or modify  	*
*   it under the terms of the GNU General Public License as published by  	*
*   the Free Software Foundation; either version 2 of the License, or     	*
*   (at your option) any later version.                                   	*
*                                                                         	*
****************************************************************************/
include('common.php');

$vars = parsed_vars();

if ($exbb['pm'] == 0 && !defined('IS_ADMIN') ) error($lang['PM'],$lang['pm_closed'],'',0);
if (!$exbb['reged']) error($lang['PM_tit'],$lang['User_unreg'],'<meta http-equiv="refresh" content="3; url=loginout.php">',true);
if (isset($vars['msg']) && ($vars['msg'] == '')) { error($lang['PM'],$lang['Dont_chg_url']);}
include($exbb['home_path'] . 'language/' . $exbb['default_lang'] . '/lang_pm.php');

switch ($vars['action']){
	case 'send'         : (isset($vars['preview']))?GreateNewPm():SendPm();break;
    case 'reply':
    case 'new':
    case 'replyquote'	: GreateNewPm();		break;
	case 'deletemsg'    : DeleteSelectedMsg();  break;
    case 'deleteall'    : DeleteallMsg();       break;
    case 'outread'      : OutReadPm();          break;
    case 'read'         : ReadPm();             break;
    case 'outbox'       : OutboxPm();           break;
    case 'inbox'        : InboxPm();            break;
    default				: FrontPm();			break;
}
include('page_tail.php');

function SendPm(){
		global $exbb,$vars,$lang,$inuser;

		$allusers = get_file($exbb['home_path'].'data/users.php',FALSE);
		$tousername = preg_replace ($lang['search'], $lang['replace'], $vars['touser']);
		$u_id = 0;
		foreach ($allusers as $id=>$info) {
        		if ($info['n'] == $tousername) {
					$u_id = $id;
					break;
				}
		}

		if (empty($u_id)) error($lang['Message_sending'],$lang['User_not_found'],'',0);
        if (substr($vars['msgtitle'],0,1)==' '){ error($lang['Message_sending'],$lang['msgtitle_probel']); }
        if (empty($vars['msgtitle']) || empty($vars['inpost']) || empty($vars['touser'])) { error($lang['Message_sending'],$lang['PM_fill']); }
        if (strlen($vars['poslanie']) > $exbb['max_posts']) {error($lang['PM'],$lang['Big_post']);}

        $fp_touser = NULL; $touserfile  = $exbb['home_path'].'members/'.$u_id.'.php';
        $touser = Get_File_Data($fp_touser,$touserfile,FALSE);

		if (!isset($touser['id']) && !isset($touser['name'])) {
            fclose($fp_touser);
			error($lang['Message_sending'],$lang['User_not_found'],'',0);
		}
        $mes_id = time();
        $touser['new_pm'] = TRUE;
        save_opened_file($fp_touser,$touser);

		$membername = $touser['name'];


		# Send the message to the user's file
		$fp_toinbox = NULL;$toinboxfile = $exbb['home_path'].'messages/'.$u_id.'-msg.php';
        $toinbox = Get_File_Data($fp_toinbox,$toinboxfile);

		# Write back to the 'to' users file
		$toinbox[$mes_id]['from']      = $exbb['member'];
		$toinbox[$mes_id]['title']     = $vars['msgtitle'];
		$toinbox[$mes_id]['msg']       = $vars['inpost'];
        $toinbox[$mes_id]['frid']      = $exbb['mem_id'];
		$toinbox[$mes_id]['ymail']     = $vars['show'];
        $toinbox[$mes_id]['status'] = FALSE;
        if ($vars['show'] == 'yes'){$toinbox[$mes_id]['fmail'] = $inuser['mail'];}
        save_opened_file($fp_toinbox,$toinbox);
		unset($toinbox);

		# Now, write it to the outbox of the sender

		$fp_fromoutbox = NULL; $fromoutboxfile = $exbb['home_path'].'messages/'.$exbb['mem_id'].'-out.php';
        $fromoutbox = Get_File_Data($fp_fromoutbox,$fromoutboxfile);

		$fromoutbox[$mes_id]['to'] = $vars['touser'];
		$fromoutbox[$mes_id]['title'] = $vars['msgtitle'];
		$fromoutbox[$mes_id]['msg'] = $vars['inpost'];
        $fromoutbox[$mes_id]['status'] = false;
        save_opened_file($fp_fromoutbox,$fromoutbox);

		#XXXXXXXXXXXXXXXXXX   E-mail    XXXXXXXXXXXXXXXXXXXXXXXXXX
		if ($exbb['emailfunctions'] && $exbb['pmnewmes'] == 1 && $touser['sendnewpm']){
			$string = $vars['inpost'];
			$searchpreg = array("#<br>#i","#\[q\]#i","#\[/q\]#i");
			$replace = array("\n","================  ================\n","\n=============   =============\n");
			$pmtext = preg_replace($searchpreg, $replace, $string);
			include('./modules/pmnewmes/pm_newmes.tpl');
			$subject = $lang['emsubnewpm'];
			sendmail($exbb['boardname'],$exbb['adminemail'],$email,$subject,$touser['mail']);
		}
		#XXXXXXXXXXXXXXXXXX   E-mail    XXXXXXXXXXXXXXXXXXXXXXXXXX
        /* ////  For fix zeros bugs  //// */
        clearstatcache();
        send_bugs(__FILE__,__LINE__,array($touserfile),29);
        /* ////  For fix zeros bugs  //// */
        error($lang['Message_sending'],"<b>$lang[Message_text] $lang[PM_for] $membername $lang[was_sent]</b><br>$lang[PM_stored]",'<meta http-equiv="refresh" content="3; url=messenger.php">',false);
}

function GreateNewPm() {
        global $exbb,$vars,$lang;

        $mes_id			= $vars['msg'];
        $touser			= Null;
        $to_user		= '???';
        $messagetitle	= Null;
        $post			= Null;
        $preview		= Null;
        if (isset($vars['touser'])){
            $touser     = getmember($vars['touser']);
            $to_user    = (is_array($touser))?$touser['name'] : '???';
        }
        if ($vars['action'] == 'reply' || $vars['action'] == 'replyquote') {
            $fp_inbox = NULL; $inboxfile  = $exbb['home_path'].'messages/'.$exbb['mem_id'].'-msg.php';
            $inbox = Get_File_Data($fp_inbox,$inboxfile);
            if (count($inbox) <= 0) {
            	fclose($fp_inbox);
            	unlink($inboxfile);
            	error($lang['PM'],$lang['Correct_post']);
            }
            if (!isset($inbox[$mes_id])){
            	fclose($fp_inbox);
            	error($lang['PM'],$lang['Correct_post']);
            }
            $sender_id	= $inbox[$mes_id]['frid'];
            $to_user	= $inbox[$mes_id]['from'];
            if ($inbox[$mes_id]['status'] === FALSE) {
                $inbox[$mes_id]['status'] = TRUE;
                save_opened_file($fp_inbox,$inbox);
            	//    
            	$fp_senderoutbox = NULL; $senderoutboxfile = $exbb['home_path'].'messages/'.$sender_id.'-out.php';
            	$senderoutbox = Get_File_Data($fp_senderoutbox,$senderoutboxfile);
            	if (isset($senderoutbox[$mes_id])){
            		$senderoutbox[$mes_id]['status'] = TRUE;
            		save_opened_file($fp_senderoutbox,$senderoutbox);
            	} else {fclose($fp_senderoutbox);}
            	if (count($senderoutbox)<=0) unlink($senderoutboxfile);
        	} else {fclose($fp_inbox);}
            unset($senderoutbox);
            $messagetitle = 'RE:'.$inbox[$mes_id]['title'];
        }
        if ($vars['action'] == 'replyquote') {
            $post = $inbox[$mes_id]['msg'];
            $post = str_replace('<br>',"\n",$post);
            $post = str_replace('<p>',"\n\n",$post);
            $post = '[quote]'.$post.'[/quote]';
        }
        if (isset($vars['preview'])){
            $to_user       = $vars['touser'];
            $messagetitle  = $vars['msgtitle'];
            $preview       = ikoncode($vars['inpost']);
            $preview       = ($exbb['emoticons']) ? setsmiles($preview):$preview;
            $post          =  str_replace('<br>',"\n",$vars['inpost']);
            $post          = str_replace('<p>',"\n\n",$post);
            include('./templates/'.$exbb['default_style'].'pm_preview.tpl');
        }

        $codemap = '<br><script language="JavaScript">ibcodes();</script>';
        $smilesmap = '<br><script language="JavaScript">ibsmiles();</script>';
        $java = "\n<script language=\"Javascript\" src=\"smilesmap.js\"></script>\n<script language=\"Javascript\" src=\"codesmap.js\"></script>";
        $title_page = $exbb['boardname'].' :: '.$lang['PM'];
        include('./templates/'.$exbb['default_style'].'all_header.tpl');
        include('./templates/'.$exbb['default_style'].'pm_new.tpl');
        include('./templates/'.$exbb['default_style'].'footer.tpl');
}

function DeleteSelectedMsg(){
        global $exbb,$vars,$lang;

        if(!isset($vars['msg'])){error($lang['PM'],"     .",'',0); }
        $fp_from = NULL;
        switch ($vars['where']){
            case  'inbox': $fromfile = $exbb['home_path'].'messages/'.$exbb['mem_id'].'-msg.php';break;
            case 'outbox': $fromfile = $exbb['home_path'].'messages/'.$exbb['mem_id'].'-out.php';break;
        }
        $fromboxbox = Get_File_Data($fp_from,$fromfile);

        $delid = array();
        $delid = $vars['msg'];
        foreach ($delid as $mes_id){
        		if (isset($fromboxbox[$mes_id])){
                    unset($fromboxbox[$mes_id]);
                } else {
                        continue;
                }
        }
        if (count($fromboxbox) >0) {
        	save_opened_file($fp_from,$fromboxbox);
		} else {
        		fclose($fp_from);
        		unlink($fromfile);
		}
        unset($fromboxbox,$delid);
        error($lang['PM'],$lang['PM_deledet_you'].$vars['where'],'<meta http-equiv="refresh" content="3; url=messenger.php?action='.$vars['where'].'">',false);
}

function DeleteallMsg(){
        global $exbb,$vars,$lang;

        switch ($vars['where']){
            case  'inbox': $filetotrash = $exbb['home_path'].'messages/'.$exbb['mem_id'].'-msg.php';break;
            case 'outbox': $filetotrash = $exbb['home_path'].'messages/'.$exbb['mem_id'].'-out.php';break;
        }
        if (file_exists($filetotrash)) {
            @unlink($filetotrash);
            error($lang['PM'],$lang['All_deleted_you'].$vars['where'],'<meta http-equiv="refresh" content="3; url=messenger.php?action='.$vars['where'].'">',false);
        } else {
                error($lang['PM'],$lang['PM_not_deleted'],'',0);
        }
}

function OutReadPm(){
        global $exbb,$vars,$lang;

        $mes_id 	= $vars['msg'];
        $replycols = Null;
        $outboxfile = 'messages/'.$exbb['mem_id'].'-out.php';
        $outbox = get_file($outboxfile,FALSE);

        if (count($outbox) <= 0){unlink($outboxfile); error($lang['PM'],$lang['Correct_post']);}
        if (!isset($outbox[$mes_id])) error($lang['PM'],$lang['Correct_post']);

        $date 			= longDate(($mes_id + $exbb['usertime']*3600),1);
        $to 			= $outbox[$mes_id]['to'];
        $messagetitle 	= $outbox[$mes_id]['title'];
        $post 			= ikoncode($outbox[$mes_id]['msg']);
        $post 			= ($exbb['emoticons']) ? setsmiles($post):$post;
        $title_page 	= $exbb['boardname'].' :: '.$lang['PM'];
        include('./templates/'.$exbb['default_style'].'all_header.tpl');
        include('./templates/'.$exbb['default_style'].'pm_outread.tpl');
        include('./templates/'.$exbb['default_style'].'footer.tpl');
}

function ReadPm(){
        global $exbb,$vars,$lang;

        $mes_id 	= $vars['msg'];
        $membername = $exbb['member'];

        $fp_inbox = NULL; $inboxfile	= $exbb['home_path'].'messages/'.$exbb['mem_id'].'-msg.php';
        $inbox 		= Get_File_Data($fp_inbox,$inboxfile);

        if (count($inbox)<=0){
            fclose($fp_inbox);
        	unlink($inboxfile);
        	error($lang['PM'],$lang['Correct_post']);
        }
        if (!isset($inbox[$mes_id]))error($lang['PM'],$lang['Correct_post']);

        $sender_id      = $inbox[$mes_id]['frid'];

        if ($inbox[$mes_id]['status'] === FALSE) {
            $inbox[$mes_id]['status'] = TRUE;
            save_opened_file($fp_inbox,$inbox);
            //    
            $fp_senderoutbox = NULL; $senderoutboxfile = $exbb['home_path'].'messages/'.$sender_id.'-out.php';
            $senderoutbox = Get_File_Data($fp_senderoutbox,$senderoutboxfile);
            if (isset($senderoutbox[$mes_id])){
            	$senderoutbox[$mes_id]['status'] = TRUE;
            	save_opened_file($fp_senderoutbox,$senderoutbox);
            } else {fclose($fp_senderoutbox);}
            if (count($senderoutbox)<=0) unlink($senderoutboxfile);
        } else {fclose($fp_inbox);}

        $date 			= longDate(($mes_id + $exbb['usertime']*3600),'1');
        $from 			= $inbox[$mes_id]['from'];
        $messagetitle	= ($exbb['wordcensor']) ? bads_filter($inbox[$mes_id]['title']) : $inbox[$mes_id]['title'];
        $post 			= ($exbb['wordcensor']) ? bads_filter($inbox[$mes_id]['msg']) : $inbox[$mes_id]['msg'];
        $post 			= ($exbb['emoticons']) ? setsmiles($post):$post;
        $post			= ikoncode($post);

        $show_address 	= $inbox[$mes_id]['ymail'];
        $yes_email    	= ($show_address == 'yes')?'| <a href="mailto:'.$inbox[$mes_id]['fmail'].'" title="'.$lang['Send_Email'].' ('.$inbox[$mes_id]['fmail'].')">'.$inbox[$mes_id]['fmail'].'</a>':'';
        $yes_email_im 	= ($show_address == 'yes')? '<a href="mailto:'.$inbox[$mes_id]['fmail'].'" title="'.$lang['Send_Email'].' ('.$inbox[$mes_id]['fmail'].')"><img src="./templates/HeliusExBB/im/pm_email.gif" alt="'.$inbox[$mes_id]['fmail'].'" border="0" /></a>':'';

        $title_page = $exbb['boardname'].' :: '.$lang['PM'];
        include('./templates/'.$exbb['default_style'].'all_header.tpl');
        include('./templates/'.$exbb['default_style'].'pm_read.tpl');
        include('./templates/'.$exbb['default_style'].'footer.tpl');
}

function OutboxPm() {
        global $exbb,$vars,$lang;

        $outboxfile = $exbb['home_path'].'messages/'.$exbb['mem_id'].'-out.php';
        $outbox =  get_file($outboxfile);
        $totaloutbox = count($outbox);
        krsort($outbox);

        //  
        $inbox_data = Null;
        if ($totaloutbox != 0){
            foreach ($outbox as $msgdate => $msg) {
                    $from = $msg['to'];
                    $messagetitle = '<a href="messenger.php?action=outread&msg='.$msgdate.'">'.$msg['title'].'</a>';
                    $readstate = '&nbsp;';
                    $date = date("d.m.Y - H:i", $msgdate + $exbb['usertime']*3600);
                    $textstate = (!$msg['status']) ? '<b>'.$lang['no'].'</b>' : $lang['yes'];
                    $imgstate  = ($msg['status']) ? '<img src="./templates/'.$exbb['default_style'].'im/readed.gif" alt="'.$lang['readed'].'" title="'.$lang['readed'].'">':'<img src="./templates/'.$exbb['default_style'].'im/not_readed.gif"  alt="'.$lang['not_readed'].'" title="'.$lang['not_readed'].'">';
                    include('./templates/'.$exbb['default_style'].'pm_inbox_data.tpl');
            }
        } else {
                unlink($outboxfile);
                $inbox_data = '<tr>
                                  <td colspan="5" class="row4" style="padding:5px;margin-top:1px" align=center valign=middle><b>There are no messages in the OutBox</b></td>
                                </tr>';
        }
        $title_page = $exbb['boardname'].' :: '.$lang['PM'];
        include('./templates/'.$exbb['default_style'].'all_header.tpl');
        include('./templates/'.$exbb['default_style'].'pm_outbox.tpl');
        include('./templates/'.$exbb['default_style'].'footer.tpl');
}

function InboxPm(){
        global $exbb,$vars,$lang,$inuser;

        $membername = $exbb['member'];

        if ($inuser['new_pm'] === TRUE) {
			$fp_curuser = NULL; $curuserfile = $exbb['home_path'].'members/'.$exbb['mem_id'].'.php';
        	$curuser = Get_File_Data($fp_curuser,$curuserfile,FALSE);
        	$curuser['new_pm'] = $inuser['new_pm'] = false;
        	save_opened_file($fp_curuser,$curuser);
        	unset($curuser);
            /* ////  For fix zeros bugs  //// */
            clearstatcache();
            send_bugs(__FILE__,__LINE__,array($curuserfile),28);
            /* ////  For fix zeros bugs  //// */
        }
		$inboxfile = $exbb['home_path'].'messages/'.$exbb['mem_id'].'-msg.php';
        $inbox =  get_file($inboxfile);
        $totalinbox = count($inbox);
        krsort($inbox);

        //  
        $inbox_data = Null;
        if ($totalinbox != 0){
            foreach ($inbox as $msgdate => $msg) {
                    $from = $msg['from'];
                    $messagetitle = '<a href="messenger.php?action=read&msg='.$msgdate.'">'.$msg['title'].'</a>';
                    $replycols = '<td class="row2" align="center" valign="middle"><a href="messenger.php?action=replyquote&msg='.$msgdate.'" title=\''.$lang['Reply'].'   "'.$msg['title'].'"\'></span></td>';
                    $textstate = (!$msg['status']) ? '<b>'.$lang['no'].'</b>' : $lang['yes'];
                    $imgstate  = ($msg['status']) ? '<img src="./templates/'.$exbb['default_style'].'im/readed.gif" alt="'.$lang['readed'].'" title="'.$lang['readed'].'">':'<img src="./templates/'.$exbb['default_style'].'im/not_readed.gif"  alt="'.$lang['not_readed'].'" title="'.$lang['not_readed'].'">';
                    $date = date("d.m.Y - H:i", $msgdate + $exbb['usertime']*3600);
                    include('./templates/'.$exbb['default_style'].'pm_inbox_data.tpl');
            }
        } else {
                unlink($inboxfile);
                $inbox_data = '<tr>
                                  <td colspan="6" class="row4" style="padding:5px;margin-top:1px" align=center valign=middle><b>There are no messages in the InBox</b></td>
                                </tr>';
        }
        $title_page = $exbb['boardname'].' :: '.$lang['PM'];
        include('./templates/'.$exbb['default_style'].'all_header.tpl');
        include('./templates/'.$exbb['default_style'].'pm_inbox.tpl');
        include('./templates/'.$exbb['default_style'].'footer.tpl');
}

function FrontPm(){
        global $exbb,$vars,$lang;

        $membername = $exbb['member'];

        $inboxfile = $exbb['home_path'].'messages/'.$exbb['mem_id'].'-msg.php';
        $unread = 0;
        $totalmessages = 0;
        $allmessages =  get_file($inboxfile);
        $totalmessages = count($allmessages);
        foreach ($allmessages as $date=>$ms) if (!$ms['status'])  $unread++;
        if ($totalmessages === 0) {
            unlink($inboxfile);
        }
        $title_page = $exbb['boardname'].' :: '.$lang['PM'];
        include('./templates/'.$exbb['default_style'].'all_header.tpl');
        include('./templates/'.$exbb['default_style'].'pm_show.tpl');
        include('./templates/'.$exbb['default_style'].'footer.tpl');
}
?>
