<?php
/***************************************************************************
* "Members Control" mods for  ExBB v.1.9.1                                 *
* Copyright (c) 2004 by Alisher Mutalov aka Markus                        *
*                                                                          *
* http://www.tvoyweb.ru                                                    *
* http://www.tvoyweb.ru/forums/                                            *
* email: admin@tvoyweb.ru                                                  *
*                                                                          *
***************************************************************************/
if (!defined('MODULE_MAIN')) die('Hack attempt!');

include($exbb['home_path'].'modules/memcontrol/language/'.$exbb['default_lang'].'/lang.php');
$vars['action'] = (isset($vars['action'])) ? $vars['action']:"";

switch ($vars['action']) {
	case 'mail'			: user_mail();	break;
	case 'deletemember'	: deletemember();	break;
	default				: memlist();		break;
}

function memlist() {
		global $exbb,$vars,$lang;

        include($exbb['home_path'].'language/'.$exbb['default_lang'].'/lang_reg.php');

        $sort 	= (array_key_exists('s',$vars)) ? $vars['s']:'';
        $order 	= (array_key_exists('order',$vars) && $vars['order'] == 'DESC') ? 'DESC' : 'ASC';

        $allusersfile		= $exbb['home_path'].'data/users.php';
        $alluserspostsfile	= $exbb['home_path'].'data/users_posts.php';
        switch ($sort) {
        		case 'p': 	$users = get_file($alluserspostsfile);
                            asort($users,SORT_NUMERIC);
        				  	break;
        		case 'n': 	$users = get_file($allusersfile);
        					uasort($users, 'sort_by_name');
        					break;
                default : 	$users = get_file($allusersfile);
                			ksort($users,SORT_NUMERIC);
                			break;
        }
        if ($order == 'DESC') $users = array_reverse($users,TRUE);

        $sort_order = '<select name="order" class="dats">';
        if ($order == 'ASC') {
            $sort_order .= '<option value="ASC" selected="selected">'.$lang['MCL_ASC'].'</option><option value="DESC">'.$lang['MCL_DESC'].'</option>';
        } elseif ($order == 'DESC') {
                $sort_order .= '<option value="ASC">'.$lang['MCL_ASC'].'</option><option value="DESC" selected="selected">'.$lang['MCL_DESC'].'</option>';
        }
        $sort_order .= '</select>';

        $sort_arr = array('d'=>$lang['Sort_join'], 'p'=>$lang['MCL_By_Post'],'n'=>$lang['Sort_name']);
        $sort_mode = '<select name="s" class="dats">';
        foreach ($sort_arr as $mode=>$name) {
                $selected = ( $mode == $sort ) ? ' selected="selected"' : '';
                $sort_mode .= '<option value="' . $mode . '"' . $selected . '>' . $name . '</option>';
        }
        $sort_mode .= '</select>';

        $p_order = '&s='.$sort.'&order='.$order;
        $total = count($users);
        $get_param = 'setmodule.php?module=memcontrol'.$p_order.'&p=%d';
        $per_page  = (array_key_exists('pg',$vars) && $vars['pg']) ? $vars['pg'] : 25 ;
		$first = 0;
        $pages = Print_Paginator($total,$get_param,$per_page,8,$first,TRUE);

        $ids = array_slice(array_keys($users),$first,$per_page);

		foreach ($ids as $key=>$uid) {
                $member = getmember($uid);
                $name 	= $member['name'];
				$posts 	= $member['posts'];

				if (!empty($member['title']) && $member['status'] != 'banned' ) {
					$title = $member['title'];
                } else {
						switch ($member['status']) {
							case 'ad' 	  : $title = $lang['Admin'];
											break;
							case 'me' 	  : $title = $lang['User'];
											break;
							case 'banned' : $title = $lang['User_banned'];
											break;
						}
				}
				$id 		= $member['id'];
				$location 	= $member['location'];
				$joined 	= date("d.m.Y", $member['joined']);
				if ($member['www'] != 'http://') {
					$www = str_replace('http://','',$member['www']);
					$www = (strlen($www) > 4) ? '<a href="http://'.$www.'" target="_blank">'.$lang['MCL_View'].'</a>' : '&nbsp;';
				}
				$email = '<a href="setmodule.php?module=memcontrol&action=mail&mid='.$uid.'">'.$lang['MCL_Write'].'</a>';
				$icq = ($member['icq']) ? '<a href="http://wwp.icq.com/scripts/search.dll?to='.$member['icq'].'"><img src="http://online.mirabilis.com/scripts/online.dll?icq='.$member['icq'].'&img=5" align=abscenter width=18 height=18 border=0></a>' : '&nbsp;';
				$class = ( !($key % 2) ) ? 'row1' : 'row4';
				include($exbb['home_path'].'modules/memcontrol/admintemplates/memb_data.tpl');
				unset($member);
		}
		include($exbb['home_path'].'admin/all_header.tpl');
		include($exbb['home_path'].'admin/nav_bar.tpl');
		include($exbb['home_path'].'modules/memcontrol/admintemplates/memblist.tpl');
		include($exbb['home_path'].'admin/footer.tpl');
}

function deletemember() {
		global $exbb,$vars,$lang;

        if(!array_key_exists('del',$vars))adminerror($lang['Info'],$lang['MCL_UsersNotSelected'],'',0);

		if (isset($vars['mode']))delet_mail();

		$deletedTotal = 0;
        include('./data/boardstats.php');
        $fp_allusers = NULL; $allusersfile = $exbb['home_path'].'data/users.php';
        $allusers = Get_File_Data($fp_allusers,$allusersfile,FALSE);
		foreach ($vars['del'] as $uid) {
			$userUnlinkFile = $exbb['home_path'].'members/'.$uid.'.php';
			if (file_exists($userUnlinkFile)) @unlink($userUnlinkFile);
			if (array_key_exists($uid,$allusers)) unset($allusers[$uid]);
            $deletedTotal++;
        }
        $exbb['totalmembers'] -= $deletedTotal;
        save_opened_file($fp_allusers,$allusers);
		save_statfile();
        adminerror($lang['Info'],$lang['User_deleted'],'<meta http-equiv="refresh" content="3; url=setmodule.php?module=memcontrol">',0);
}

function delet_mail() {
		global $exbb,$lang,$vars;

        foreach ($vars['del'] as $uid) {
				if ($inuser = getmember($uid)) {
                	$to_bcc = $inuser['mail'];
                    $name = $inuser['name'];
                    $joined = date("d.m.Y", $inuser['joined']);
                    include($exbb['home_path'].'modules/memcontrol/admintemplates/del_mail.tpl');
                    sendmail($exbb['boardname'],$exbb['adminemail'],$email,$lang['MCL_Your_AcDel'],$to_bcc);
                } else {
                       adminerror($lang['Info'],$lang['Email_error'],'',0);
                }
        }
        adminerror($lang['Info'],$lang['Message_sent'],'<meta http-equiv="refresh" content="3; url=setmodule.php?module=memcontrol">',0);
}

function user_mail() {
		global $exbb,$vars,$lang;

		include($exbb['home_path'].'language/' . $exbb['default_lang'] . '/lang_admin.php');
		$filetoopen = $exbb['home_path'].'data/users.php';
		if (isset($vars['mode'])) {
			$users = get_file($filetoopen,FALSE);
			if (isset($vars['mid'])) {
				if (array_key_exists($vars['mid'],$users)) {
					$member = getmember($vars['mid']);
					$message = $lang['Hello'].', '.$member['name']."\n".$exbb['member'].$lang['Email_from'].$exbb['boardname'].' ('.$exbb['boardurl'].")\n\n";
					$message .= stripslashes(trim($_POST['message']));
					sendmail($exbb['member'],$users[$exbb['mem_id']]['m'],$message,$vars['subject'],$users[$vars['mid']]['m']);
				} else {
						adminerror($lang['Info'],$lang['Email_error'],'',0);
				}
				adminerror($lang['Info'],$lang['Message_sent'],'<meta http-equiv="refresh" content="3; url=setmodule.php?module=memcontrol">',0);
			}
			adminerror($lang['Info'],$lang['Message_sent'],'<meta http-equiv="refresh" content="3; url=setmodule.php?module=memcontrol">',0);
		} else {
				include($exbb['home_path'].'admin/all_header.tpl');
				include($exbb['home_path'].'admin/nav_bar.tpl');
				if (isset($vars['mid'])) {
					$member = getmember($vars['mid']);
					$hidden = '<input type=hidden name="mid" value="'.$vars['mid'].'">';
				}

				include($exbb['home_path'].'modules/memcontrol/admintemplates/user_mail.tpl');
				include($exbb['home_path'].'admin/footer.tpl');
		}
}

function sort_by_post($a, $b) {
		if ($a['posts'] == $b['posts']) {
			return 0;
		}
		return ($a['posts'] < $b['posts']) ? -1 : 1;
}

function sort_by_name($a, $b) {
		return strcmp($a['n'], $b['n']);
}

function Print_Paginator($total,$get,$per,$links,&$first,$dots = FALSE) {
        global $vars,$current_page;
        $p = (!isset($vars['p'])) ? 0 : intval($vars['p']);
        ///////////////////
        $total_pages	= ceil($total/$per);
        $current_page	= ($p <= 0)? 1:(($p<=$total_pages) ? $p:$total_pages);
        $first			= ($current_page <= 1) ? 0 : ($current_page-1)*$per;
        ////////////////
        $paginator = '<b></b> ('.$total_pages.'): ';
        $pagesarray = array();
        $pos = floor($links/2);
        $links = $pos*2+1;

        $go_start = $go_finish = "";
        if ($total_pages > $links) {
            $go_start  = ($current_page - $pos <= 1) ? '':' <a href="'.sprintf($get,'1').'" title=" "> </a> ';
            $go_finish = ($current_page + $pos >= $total_pages) ? '':' <a href="'.sprintf($get,$total_pages).'" title=" "> </a> ';
        }

        $prev = ($current_page == 1)?'':'<a href="'.sprintf($get,($current_page-1)).'" title=" ">&laquo;</a> ';
        $next = ($current_page == $total_pages)?'':' <a href="'.sprintf($get,($current_page+1)).'" title=" ">&raquo;</a>';
        $dots_start = NULL; $dots_finish = NULL;
        if ($dots === TRUE && $total_pages > $links){
			$dots_start  = ($current_page - $pos <= 1) ? '':'... ';
            $dots_finish = ($current_page + $pos >= $total_pages) ? '':' ...';
        }

        $start_links  =
            ($total_pages > $links) ? (
                      ($current_page - $pos <= 1) ? 1 : (
                                ($current_page + $pos >= $total_pages) ? $total_pages - $pos*2 : $current_page - $pos
                      )
            ) : 1;
        $finish_links =
             ($total_pages > $links) ? (
                       ($current_page + $pos >= $total_pages) ? $total_pages : (
                                    ($current_page - $pos <= 1) ? $links : $current_page + $pos
                       )
             ) : $total_pages;


        for ($i=$start_links; $i<=$finish_links; $i++){
			$start  = ($i-1)*$per+1;
            $pagesarray[] = ($i != $current_page)?'<a href="'.sprintf($get,$i).'">'.$i.'</a>':'['.$i.']';
        }
        $paginator .= $go_start.$prev.$dots_start;
        $paginator .= implode(" ",$pagesarray);
        $paginator .= $dots_finish.$next.$go_finish;
        return $paginator;
}
?>
