<?php
/****************************************************************************
* ExBB v.1.1                                                              	*
* Copyright (c) 2002-20 by Alexander Subhankulov aka Warlock            	*
*                                                                         	*
* http://www.exbb.net                                             			*
* email: admin@exbb.net                                           			*
*                                                                         	*
****************************************************************************/
/****************************************************************************
*                                                                         	*
*   This program is free software; you can redistribute it and/or modify  	*
*   it under the terms of the GNU General Public License as published by  	*
*   the Free Software Foundation; either version 2 of the License, or     	*
*   (at your option) any later version.                                   	*
*                                                                         	*
****************************************************************************/

include('common.php');
$vars = parsed_vars();

include($exbb['home_path'] . 'language/' . $exbb['default_lang'] . '/lang_edit.php');

if (!$exbb['reged']) {
	error($lang['Message_edit'],$lang['Guest_no_edit']);
}
#XXXXXXXXXXXX    XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
if ($exbb['punish'] == TRUE){
	include($exbb['home_path'].'modules/punish/p_error.php');
}
#XXXXXXXXXXXX    XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
$action = (isset($vars['action'])) ?$vars['action']:"";


if ($action == 'edit') {editform();}
elseif ($action == 'processedit' && $vars['previewfirst'] == 'yes') {editform();}
elseif ($action == 'processedit' && $vars['previewfirst'] == 'no') {processedit();}
elseif ($action == 'processedit' && $vars['deletepost'] == 'yes') {deletepost();}
elseif ($action == 'edittopic') {edit_topic_title();}
elseif ($action == 'delete') {deletethread();}
elseif ($action == 'movetopic') {movetopic();}
elseif ($action == 'restore') {restore();}
elseif ($action == 'top_recount') {top_recount();}
elseif ($action == 'poll') {poll_edit();}
elseif (($action == 'lock') or ($action == 'unlock')) {un_lockthread($action);}
elseif (($action == 'pin') or ($action == 'unpin')) {un_pinthread($action);}
elseif ($action == 'trackers') {del_subscribed();}
elseif ($action == 'preport' && $exbb['preport'] == 1) {preport();}
else {error($lang['Main_msg'],$lang['Correct_post']); }

include('page_tail.php');

function editform() {
		global $exbb,$lang,$vars,$inuser;

  		$allforumsfile = $exbb['home_path'].'data/allforums.php';
  		$forum = get_file($allforumsfile,FALSE);

  		$inforum = $vars['forum'];
  		$intopic = $vars['topic'];
  		$in_file = '';
  		list($id,$in_file,$in_page) = explode(':',$vars['id']);
  		$inmembmod = moderator($inforum,$forum);

  		if ($forum[$inforum]['private'] && !$inuser['private'][$inforum]) {
  			error($lang['Message_edit'],$lang['Editing_cant']);
  		}
		$forumname = stripslashes($forum[$inforum]['name']);

		if ($forum[$inforum]['codes']) {
   			$codemap = '<br><script language="JavaScript">ibcodes();</script>';
   			$smilesmap = '<br><script language="JavaScript">ibsmiles();</script>';
   			$java = '<script language="Javascript" src="smilesmap.js"></script><script language="Javascript" src="codesmap.js"></script>';
		}
		### Grab the post to edit

   		$topicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$in_file.'.php';
   		$allmessages = get_file($topicfile,FALSE);

   		if (!isset($allmessages[$id])) error($lang['Message_edit'],$lang['Dont_chg_url']);

   		if (!$inmembmod && $allmessages[$id]['p_id'] != $exbb['mem_id']) error($lang['Message_edit'],$lang['Editing_not_author']);

   		if (isset($allmessages[$id]['lockedit']) && !$inmembmod) error($lang['Message_edit'],$lang['Editing_blocked']);
   		if (isset($allmessages[$id]['ad_edited']) && isset($allmessages[$id]['lockedit']) && !defined('IS_ADMIN')) error($lang['Message_edit'],$lang['Editing_after_ad']);

   		$listfile = $exbb['home_path'].'forum'.$inforum.'/list.php';
   		$list = get_file($listfile);

   		$topictitle = $list[$intopic]['name'];
   		$is_poll = ($list[$intopic]['poll']) ? true : false;

   		if (!$inmembmod && $list[$intopic]['state'] == 'closed') error($lang['Message_edit'],$lang['Edit_closed']);

   		unset($list);

   		if ($vars['previewfirst'] == 'yes') {
     		if (strlen($_POST['inpost']) > $exbb['max_posts']) {error($lang['Message_sending'],$lang['Big_post']);}
     		if (strlen(trim($_POST['inpost'])) < 1) {error($lang['Message_sending'],$lang['Mess_needed']);}
     		$preview = str_replace( '$' , '&#036;' , $vars['inpost'] );
     		$preview = ikoncode($preview);
     		if ($exbb['emoticons']) { $preview = setsmiles($preview); }
     		$preview = bads_filter($preview);
     		include('./templates/'.$exbb['default_style'].'preview.tpl');
     		unset($preview);
     		$vars['pollansw'] = $_POST['pollansw'];
     		$mo_edit = stripslashes($_POST['mo_edit']);
   		} else {
     			if ($is_poll) {
       				$pollfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-poll.php';
       				$poll_data = get_file($pollfile,FALSE);
       				$vars['pollname'] = $poll_data['pollname'];
       				$poll_chces = unserialize( $poll_data['choices']);
       				$vars['pollansw'] = '';
       				foreach ($poll_chces as $choice)  $vars['pollansw'] .= $choice[1]."\n";
       				unset($poll_chces,$poll_data,$filetoopen);
     			}
   		}

   		$upload = (isset($forum[$inforum]['upload']) && !empty($forum[$inforum]['upload']) && $exbb['file_upload']) ? $forum[$inforum]['upload'] : 0;
   		if ($upload && $inuser['upload']) {
     		$enctype = ' enctype="multipart/form-data"';
     		$hidden = '<input type="hidden" name="MAX_FILE_SIZE" value="'.$upload.'">';
     		$filetoup = $lang['File_upload'].$upload.'<br />   : '.$exbb['file_type'].'<br />';
     		if (isset($allmessages[$id]['attach_id'])) {
       			$filetoup .= $lang['Keep_attach'].'( '.$allmessages[$id]['attach_file'].' )<br />';
       			$filetoup .= $lang['Del_attach'].'<br />';
       			$filetoup .= $lang['Replace_attach'].'<br /><input class="input" type="file" size="30" name="FILE_UPLOAD">';
     		} else {
       				$filetoup .= '<input class="input" type="file" size="30" name="FILE_UPLOAD">';
     		}
   		}
   		if (!isset($vars['inpost'])) {
     		$rawpost = str_replace('<p>',"\n\n",$allmessages[$id]['post']);
     		$rawpost = str_replace('<br>',"\n",$rawpost);
     		$rawpost = stripslashes($rawpost);
     		$mo_edit = stripslashes($allmessages[$id]['mo_text']);
   		} else {
   				$rawpost = stripslashes($_POST['inpost']);
   		}

   		$checked = ($allmessages[$id]['sig']) ? ' checked' : '';
   		$lockedit = ( isset($vars['lockedit']) ) ? ' checked' : '';
   		$sig_show = '<input type=checkbox name="inshowsignature" value="yes"'.$checked.'>'.$lang['Do_sig'].'<br>';

   		if ($exbb['emoticons']) {
     		$emoticonslink = '<a href="tools.php?action=smiles" target=_blank>'.$lang['Smiles_on'].'</a>';
     		$checked = ($allmessages[$id]['smiles']) ? ' checked' : '';
     		$emoticonsbutton = '<input type=checkbox name="inshowemoticons" value="yes"'.$checked.'>'.$lang['Do_smiles'].'<br>';
   		}

   		$title_page = $exbb['boardname'].' :: '.$lang['Message_edit'];
   		include('./templates/'.$exbb['default_style'].'all_header.tpl');
   		include('./templates/'.$exbb['default_style'].'post_edit.tpl');
   		include('./templates/'.$exbb['default_style'].'footer.tpl');
} # end edit form

function processedit() {
		global $exbb,$lang,$vars,$inuser,$inmembmod;

        if ($vars['request_method'] != 'post') { error($lang['Main_msg'],$lang['Correct_post']);}
        post_size();

        $inforum = $vars['forum'];
        $intopic = $vars['topic'];
        $in_file = '';
        list($id,$in_file,$in_page) = explode(':',$vars['id']);

		$allforumsfile = $exbb['home_path'].'data/allforums.php';
  		$forum = get_file($allforumsfile, FALSE);

  		$inmembmod = moderator($inforum,$forum);

  		if ($forum[$inforum]['private'] && !$inuser['private'][$inforum]) {
  			error($lang['Message_edit'],$lang['Editing_cant']);
  		}

  		$fp_topic = NULL; $topicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$in_file.'.php';
        if (!file_exists($topicfile)) error($lang['Message_edit'],$lang['Dont_chg_url']);

  		$allmessages = Get_File_Data($fp_topic,$topicfile,FALSE);
        if (!isset($allmessages[$id])) {
  			fclose($fp_topic);
  			error($lang['Message_edit'],$lang['Dont_chg_url']);
  		}

  		if (!$inmembmod && $allmessages[$id]['p_id'] != $exbb['mem_id']) {
  			fclose($fp_topic);
  		   	error($lang['Message_edit'],$lang['Editing_not_author']);
  		}

  		$edit_date = time();

  		if ($inmembmod && !defined('IS_ADMIN') && $vars['modertext'] == 'yes') { #edition by moderator but not admin
     		if ($allmessages[$id]['p_id'] != $exbb['mem_id']) {
        		$allmessages[$id]['mo_editor'] = $exbb['member'];
        		if ($vars['mo_edit'] != '') $allmessages[$id]['mo_text'] = soft_clr_value($_POST['mo_edit']);
        		$allmessages[$id]['mo_edited'] = $edit_date;
        		if (isset($vars['lockedit'])) {
        			$allmessages[$id]['lockedit'] = true;
        		} else {
        				unset($allmessages[$id]['lockedit']);
        		}
     		}
   		} elseif (defined('IS_ADMIN') && $vars['modertext'] == 'yes') { #edition by admin
     			if ($allmessages[$id]['p_id'] != $exbb['mem_id']) {
        			$allmessages[$id]['ad_editor'] = $exbb['member'];
        			if ($vars['mo_edit'] != '') $allmessages[$id]['mo_text'] = soft_clr_value($_POST['mo_edit']);
        			$allmessages[$id]['ad_edited'] = $edit_date;
        			if (isset($vars['lockedit'])) {
        				$allmessages[$id]['lockedit'] = true;
        			} else {
        					unset($allmessages[$id]['lockedit']);
        			}
        			unset($allmessages[$id]['mo_editor'],$allmessages[$id]['mo_edited']);
     			}
   		} else { #and user
				if (!$inmembmod)$allmessages[$id]['edited'] = $edit_date;
   		}
   		if ($inmembmod && $allmessages[$id]['p_id'] == $exbb['mem_id']) $vars['inpost'] = soft_clr_value($_POST['inpost']);

   		$allmessages[$id]['post'] = preg_replace( "#(\?|&amp;|;|&)PHPSESSID=([0-9a-zA-Z]){32}#i", "", $vars['inpost'] );
   		$allmessages[$id]['smiles'] = ($vars['inshowemoticons'] == 'yes') ? true : false;
   		$allmessages[$id]['sig'] = ($vars['inshowsignature'] == 'yes') ? true : false;

   		$upload = (isset($forum[$inforum]['upload']) && !empty($forum[$inforum]['upload']) && $exbb['file_upload']) ? $forum[$inforum]['upload'] : 0;

   		if (isset($vars['editattach'])) {
     		$filetoopen = $exbb['home_path'].'forum'.$inforum.'/attaches-'.$intopic.'.php';
     		$t_attaches = get_file($filetoopen);
     		$attach_id = $allmessages[$id]['attach_id'];
     		$attach_name = $t_attaches[$attach_id]['id'];
     		if ($vars['editattach'] == 'del') {
       			unset($allmessages[$id]['attach_id'],$allmessages[$id]['attach_file']);
       			unset($t_attaches[$attach_id]);
       			save_file($filetoopen,$t_attaches);
       			$filetoopen = $exbb['home_path'].'uploads/'.$attach_name;
       			@unlink($filetoopen);
     		} elseif ($vars['editattach'] == 'rep' && $upload) {
       				$exbb['uploadsize'] = $upload;
       				$attach = attach_upload($attach_id,$attach_name);
       				$allmessages[$id]['attach_file'] = $attach['attach_file'];
     		}
   		} elseif ($upload && $inuser['upload']) {
       			$exbb['uploadsize'] = $upload;
       			$attach = attach_upload();
       			if (!empty($attach['attach_id']) && !empty($attach['attach_file'])) {
         			$allmessages[$id]['attach_id'] = $attach['attach_id'];
         			$allmessages[$id]['attach_file'] = $attach['attach_file'];
       			}
   		}

   		save_opened_file($fp_topic,$allmessages);
   		unset($allmessages);
        /* ////  For fix zeros bugs  //// */
        clearstatcache();
        send_bugs(__FILE__,__LINE__,array($topicfile),8);
        /* ////  For fix zeros bugs  //// */
   		$relocurl = 'topic.php?forum='.$inforum.'&topic='.$intopic.'&start='.$in_page.'#'.$id;

   		$title_page = $exbb['boardname'].' :: '.$lang['Edit_complete'];
   		$ok_title = $lang['Edit_complete'];
   		$url1 = '<li><a href="topic.php?forum='.$inforum.'&topic='.$intopic.'">'.$lang['Return_in_topic'].'</a> ';
   		$url2 = '<li><a href="forums.php?forum='.$inforum.'">'.$lang['Return_in_forum'].'</a>';
   		$url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
   		include('./templates/'.$exbb['default_style'].'all_header.tpl');
   		include('./templates/'.$exbb['default_style'].'postok.tpl');
   		include('./templates/'.$exbb['default_style'].'footer.tpl');
} # end routine

function deletepost() {
		global $exbb,$lang,$vars,$inuser;

        $inforum = $vars['forum'];
        $intopic = $vars['topic'];
        $in_file = '';
        list($id,$in_file,$in_page) = explode(':',$vars['id']);

		$fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
    	$forum = Get_File_Data($fp_allforums,$allforumsfile,FALSE);
    	$inmembmod = moderator($inforum,$forum);

    	if (!$inmembmod) {
            fclose($fp_allforums);
    		error($lang['Post_deleting'],$lang['Edit_no']);
    	}

        $fp_topic = NULL; $topicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$in_file.'.php';
        if (!file_exists($topicfile)) {
            fclose($fp_allforums);
        	error($lang['Main_msg'],$lang['Dont_chg_url']);
        }
        $allmessages = Get_File_Data($fp_topic,$topicfile,FALSE);

        if (!isset($allmessages[$id])) {
            fclose($fp_allforums);
            fclose($fp_topic);
        	error($lang['Main_msg'],$lang['Dont_chg_url']);
        }

        ksort($allmessages,SORT_NUMERIC);
        reset($allmessages);
        #First message in topic?
        if (empty($in_file)) {
          	$check_key = key($allmessages);
          	if ($id == $check_key) {
                fclose($fp_allforums);
            	fclose($fp_topic);
        		error($lang['Post_deleting'],$lang['Post_deleting_first']);
          	}
        }

        $last = false;
        end($allmessages);
        $check_key = key($allmessages);

        if ($id == $check_key) $last = true;

        $poster = isset($allmessages[$id]['p_id']) ? $allmessages[$id]['p_id'] : 0;

        if (isset($allmessages[$id]['attach_id'])) {
          	$filetoopen = $exbb['home_path'].'forum'.$inforum.'/attaches-'.$intopic.'.php';
          	$t_attaches = get_file($filetoopen);
          	$attach_id = $allmessages[$id]['attach_id'];
          	$attach_name = $t_attaches[$attach_id]['id'];
          	unset($t_attaches[$attach_id]);
          	save_file($filetoopen,$t_attaches);
          	$filetoopen = $exbb['home_path'].'uploads/'.$attach_name;
          	@unlink($filetoopen);
        }
        ### First off, lets delete the post in the thread.
        unset($allmessages[$id]);

        end($allmessages);
        $check_key = key($allmessages);
        $last_post = $allmessages[$check_key];

        save_opened_file($fp_topic,$allmessages);
        unset($allmessages);

        $fp_list = NULL; $listfile = $exbb['home_path'].'forum'.$inforum.'/list.php';
        $list = Get_File_Data($fp_list,$listfile,FALSE);

        if ($last) {
			$last_user = ($last_post['p_id'] != 0 && checkuser($last_post['p_id'])) ? get_file($exbb['home_path'].'/members/'.$last_post['p_id'].'.php',FALSE) : false;
            if (!$last_user) {
            	$last_user['name'] = false;
                $last_user['id'] = 0;
            }

           	$list[$intopic]['poster'] = $last_user['name'];
            $list[$intopic]['p_id'] = $last_user['id'];
            $list[$intopic]['postdate'] = $check_key;
        }

        $list[$intopic]['posts']--;
        if (!empty($in_file)) {
           	$extmode = unserialize($list[$intopic]['ext']);
           	$extmode[$in_file]--;

            $in_file_next = $in_file + 1;
            $in_file_cur = $in_file;

            if ($extmode[$in_file_cur] <= 0 && isset($extmode[$in_file_next]) ) {
            	for ($in_file_cur = $in_file; $in_file_cur <= $list[$intopic]['fls']-1; $in_file_cur++) {
                	$in_file_next = $in_file_cur + 1;
                    $extmode[$in_file_cur] = $extmode[$in_file_next];
                    copy($exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$in_file_next.'.php', $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$in_file_cur.'.php');
                    unlink($exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$in_file_next.'.php');
               	}
                unset($extmode[$list[$intopic]['fls']]);

                $list[$intopic]['ext'] = serialize($extmode);
                $list[$intopic]['fls']--;
            } elseif ($extmode[$in_file_cur] <= 0 && $list[$intopic]['fls'] == 1) {
            		unset($list[$intopic]['fls'],$list[$intopic]['ext']);
                    unlink($exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd1.php');
                    $in_page = 1;
            } elseif ($extmode[$in_file_cur] <= 0 && $list[$intopic]['fls'] == $in_file) {
            		echo 'last';
                    $list[$intopic]['fls']--;
                    unset($extmode[$in_file]);
                    $list[$intopic]['ext'] = serialize($extmode);
                    unlink($exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$in_file.'.php');
                    $in_page--;
            } else {
            		$list[$intopic]['ext'] = serialize($extmode);
            }
            unset($extmode);
        }
        save_opened_file($fp_list,$list);

        if ($forum[$inforum]['last_post_id'] == $intopic && $last) {
        	$forum[$inforum]['last_poster'] = ($last_user['name']) ? $last_user['name'] : $lang['Unreg'];
           	$forum[$inforum]['last_time'] = $check_key;
           	$forum[$inforum]['last_poster_id'] = $last_user['id'];
        }
        $forum[$inforum]['posts']--;
        save_opened_file($fp_allforums,$forum);

        access_log($exbb['member'].' -     - '.$list[$intopic]['name'].' -   '.$forum[$inforum]['name']);
        unset($forum,$list,$last_user);

        #     ,   
        if ($poster != 0 && checkuser($poster)) {
        	$fp_curuser = NULL; $curuserfile = $exbb['home_path'].'members/'.$poster.'.php';
        	$user = Get_File_Data($fp_curuser,$curuserfile,FALSE);
        	if ($user['posts'] > 0) $user['posts']--;
        	$user['posted'][$inforum] = (isset($user['posted'][$inforum]) && $user['posted'][$inforum] != "") ? $user['posted'][$inforum]:0;
        	$user['posted'][$inforum]--;
        	if ($user['posted'][$inforum] <= 0) unset($user['posted'][$inforum]);
        	save_opened_file($fp_curuser,$user);
        }
        include('./data/boardstats.php');

        $exbb['totalposts']--;
        save_statfile();

        /* ////  For fix zeros bugs  //// */
        clearstatcache();
        $bugarray = (isset($curuserfile)) ? array($allforumsfile,$topicfile,$listfile,$curuserfile):array($allforumsfile,$topicfile,$listfile);
        send_bugs(__FILE__,__LINE__,array($allforumsfile,$topicfile,$listfile,$curuserfile),9);
        /* ////  For fix zeros bugs  //// */

        $title_page = $exbb['boardname'].' :: '.$lang['Post_deleted'];
        $ok_title = $lang['Post_deleted'];
        $relocurl = 'topic.php?forum='.$inforum.'&topic='.$intopic.'&start='.$in_page;
        $url1 = '<li><a href="'.$relocurl.'">'.$lang['Return_in_topic'].'</a> ';
        $url2 = '<li><a href="forums.php?forum='.$inforum.'">'.$lang['Return_in_forum'].'</a>';
        $url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
        include('./templates/'.$exbb['default_style'].'all_header.tpl');
        include('./templates/'.$exbb['default_style'].'postok.tpl');
        include('./templates/'.$exbb['default_style'].'footer.tpl');
} # end subdelete

function edit_topic_title() {
		global $exbb,$lang,$vars,$inuser;

    	if ($vars['request_method'] != 'post') {
    		error($lang['Main_msg'],$lang['Correct_post']);
    	}
        $inforum = $vars['forum'];
        $intopic = $vars['topic'];

        $fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
        $forum = Get_File_Data($fp_allforums,$allforumsfile,FALSE);
        $inmembmod = moderator($inforum,$forum);

    	if (!$inmembmod) {
            fclose($fp_allforums);
    		error($lang['Message_edit'],$lang['Edit_no']);
    	}
        $fp_list = NULL; $listfile = $exbb['home_path'].'forum'.$inforum.'/list.php';
        $list = Get_File_Data($fp_list,$listfile,FALSE);

    	if ($vars['checked'] == 'yes') {
        	if ($vars['intopictitle'] == '') {
                fclose($fp_allforums);
                fclose($fp_list);
        		error($lang['Message_edit'],$lang['Title_needed']);
        	}

        	if ($forum[$inforum]['last_post_id'] == $intopic) {
                $forum[$inforum]['last_post'] = $vars['intopictitle'];
          		save_opened_file($fp_allforums,$forum);
        	} else {
					fclose($fp_allforums);
        	}


        	$list[$intopic]['name'] = $vars['intopictitle'];
        	if (!empty($vars['intopicdescription'])) {
        		$list[$intopic]['desc'] = $vars['intopicdescription'];
        	} else {
        			unset($list[$intopic]['desc']);
        	}
        	save_opened_file($fp_list,$list);
			#XXXXXXXXXXXXXXX       XXXXXXXXXXXXXXXXXXXXXXXXXXX
        	$fp_topic = NULL; $topicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd.php';
        	$topicdata = Get_File_Data($fp_topic,$topicfile,FALSE);
        	$topicdata[$list[$intopic]['date']]['desc'] = (!empty($vars['intopicdescription']))?$vars['intopicdescription']:'';
        	$topicdata[$list[$intopic]['date']]['name'] = $vars['intopictitle'];
        	save_opened_file($fp_topic,$topicdata);
			#XXXXXXXXXXXXXX       XXXXXXXXXXXXXXXXXXXXXXXXXXXX

            /* ////  For fix zeros bugs  //// */
        	clearstatcache();
        	send_bugs(__FILE__,__LINE__,array($allforumsfile,$listfile),10);
        	/* ////  For fix zeros bugs  //// */

        	$title_page = $exbb['boardname'].' :: '.$lang['Edit_complete'];
        	$ok_title = $lang['Edit_complete'];
        	$relocurl = 'topic.php?forum='.$inforum.'&topic='.$intopic;
        	$url1 = '<li><a href="'.$relocurl.'">'.$lang['Return_in_topic'].'</a>';
        	$url2 = '<li><a href="forums.php?forum='.$inforum.'">'.$lang['Return_in_forum'].'</a>';
        	$url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
        	include('./templates/'.$exbb['default_style'].'all_header.tpl');
        	include('./templates/'.$exbb['default_style'].'postok.tpl');
        	include('./templates/'.$exbb['default_style'].'footer.tpl');
    	} else {
                fclose($fp_allforums);
                fclose($fp_list);

        		$old_topictitle = $list[$intopic]['name'];
        		$old_topicdescription = $list[$intopic]['desc'];
        		unset($list);
        		$title_page = $exbb['boardname'].' :: '.$lang['Edit_title'];
        		include('admin/all_header.tpl');
        		include('admin/edit_topic_title.tpl');
        		include('page_tail_admin.php');
    	}
} # end edit topic

function deletethread() {
		global $exbb,$lang,$vars,$inuser;

        if ($vars['request_method'] != 'post') {
			error($lang['Main_msg'],$lang['Correct_post']);
		}
        $inforum = $vars['forum'];
        $intopic = $vars['topic'];

        $fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
        $forum = Get_File_Data($fp_allforums,$allforumsfile,FALSE);

    	$inmembmod = moderator($inforum,$forum);

    	if (!$inmembmod) {
            fclose($fp_allforums);
    		error($lang['Topic_deleting'],$lang['Edit_no']);
    	}

    	if (isset($vars['checked']) && $vars['checked'] == "yes") {
			$fp_list = NULL; $listfile = $exbb['home_path'].'forum'.$inforum.'/list.php';
        	$list = Get_File_Data($fp_list,$listfile,FALSE);

        	###   
        	include('./data/boardstats.php');

        	$exbb['totalthreads']--;
        	$exbb['totalposts'] -= $list[$intopic]['posts'];
        	save_statfile();

        	$forum[$inforum]['posts'] -= $list[$intopic]['posts'];
        	$forum[$inforum]['topics']--;
        	###    list.php

        	unset($list[$intopic]);
        	save_opened_file($fp_list,$list);

            ###         ,  ,    :)

        	if ($forum[$inforum]['last_post_id'] == $intopic) {
           		reset($list);
           		$last_id = key($list);
           		$forum[$inforum]['last_post'] = $list[$last_id]['name'];
           		$forum[$inforum]['last_post_id'] = $last_id;
           		$forum[$inforum]['last_poster'] = $list[$last_id]['poster'];
           		$forum[$inforum]['last_time'] = $list[$last_id]['postdate'];
        	}

        	#       ,   

        	save_opened_file($fp_allforums,$forum);
        	unset($list);

        	### Now we have to trash it from the thd's
        	@unlink($exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd.php');

        	$files = 1;
        	$topicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$files.'.php';
        	while (file_exists($topicfile)) {
          			@unlink($topicfile);
          			$files++;
          			$topicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$files.'.php';
        	}

        	$pinnedfile = $exbb['home_path'].'forum'.$inforum.'/_pinned.php';
        	$sticked = get_file($pinnedfile);
        	if (is_array($sticked) && count($sticked)) {
            	unset($sticked[$intopic]);
            	save_file($pinnedfile,$sticked);
        	}

        	$filetotrash = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-m.php';
        	@unlink($filetotrash);
        	$filetounlink = $exbb['home_path'].'forum'.$inforum.'/attaches-'.$intopic.'.php';
        	@unlink($filetounlink);
        	$filetounlink = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-poll.php';
        	@unlink($filetounlink);

            /* ////  For fix zeros bugs  //// */
        	clearstatcache();
        	send_bugs(__FILE__,__LINE__,array($allforumsfile,$listfile),11);
        	/* ////  For fix zeros bugs  //// */

        	$title_page = $exbb['boardname'].' :: '.$lang['Topic_deleted'];
        	$ok_title = $lang['Topic_deleted'];
        	$relocurl = 'forums.php?forum='.$inforum;
        	$url1 = '<li><a href="forums.php?forum='.$inforum.'">'.$lang['Go_to_old'].'</a>';
        	$url2 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
        	$url3 = '';
        	include('./templates/'.$exbb['default_style'].'all_header.tpl');
        	include('./templates/'.$exbb['default_style'].'postok.tpl');
        	include('./templates/'.$exbb['default_style'].'footer.tpl');
		} else {
        		$title_page = $exbb['boardname'].' :: '.$lang['Topic_deleting'];
        		include('admin/all_header.tpl');
        		include('admin/deletetopic.tpl');
        		include('page_tail_admin.php');
		}
} # end deletethread

function movetopic() {
		global $exbb,$lang,$vars,$inuser;

   		if ($vars['request_method'] != 'post') {
			error($lang['Main_msg'],$lang['Correct_post']);
		}
        $fromforum_id   = $vars['forum'];
        $toforum_id     = $vars['movetoid'];
        $oldtopic_id    = $vars['topic'];

        $fp_allforums = NULL; $allforumsfile = $exbb['home_path'].'data/allforums.php';
        $allforums = Get_File_Data($fp_allforums,$allforumsfile);

    	$inmembmod = moderator($fromforum_id,$allforums);

    	if (!$inmembmod) {
            fclose($fp_allforums);
    		error($lang['Topic_moving'],$lang['Edit_no']);
        }
		if (isset($vars['checked']) && $vars['checked'] == 'yes' && $toforum_id != '') {
            if ($toforum_id == $fromforum_id || !isset($allforums[$toforum_id])){
            	fclose($fp_allforums);
            	error($lang['Topic_moving'],$lang['Moving_error']);
            }

    		### Get a new thread number.
            $fp_tolist = NULL; $tolistfile = $exbb['home_path'].'forum'.$toforum_id.'/list.php';
            $tolist = Get_File_Data($fp_tolist,$tolistfile);
            $keys = array_keys($tolist);
            $newtopic_id = (count($keys) !== 0) ? max($keys) + 1:1;

            $oldtopicfile = $exbb['home_path'].'forum'.$fromforum_id.'/'.$oldtopic_id.'-thd.php';
			$newtopicfile = $exbb['home_path'].'forum'.$toforum_id.'/'.$newtopic_id.'-thd.php';

    		@copy($oldtopicfile,$newtopicfile);
    		@chmod($newtopicfile,$exbb['ch_files']);
            if ($vars['leavemessage'] == 'yes') {
        		$fp_oldtopic = NULL;
        		$oldtopic = Get_File_Data($fp_oldtopic,$oldtopicfile);
                ksort($oldtopic,SORT_NUMERIC);
      			reset($oldtopic);
      			$firstkey = key($oldtopic);
                $oldtopic[$firstkey]['state'] = 'moved';
                $oldtopic[$firstkey]['movedid'] = $toforum_id.':'.$newtopic_id;
                save_opened_file($fp_oldtopic,$oldtopic);
                unset($oldtopic);
      		}

    		$files = 1;
    		$oldtopicfiles = $exbb['home_path'].'forum'.$fromforum_id.'/'.$oldtopic_id.'-thd'.$files.'.php';
    		while (file_exists($oldtopicfiles)) {
      				@copy($oldtopicfiles,$exbb['home_path'].'forum'.$toforum_id.'/'.$newtopic_id.'-thd'.$files.'.php');
      				if ($vars['leavemessage'] != 'yes') {
        				@unlink($oldtopicfiles);
      				}
      				$files++;
      				$oldtopicfiles = $exbb['home_path'].'forum'.$fromforum_id.'/'.$oldtopic_id.'-thd'.$files.'.php';
    		}
            //attaches
    		$oldattachesfile = $exbb['home_path'].'forum'.$fromforum_id.'/attaches-'.$oldtopic_id.'.php';
    		if (file_exists($oldattachesfile)) {
      			$newattachesfile = $exbb['home_path'].'forum'.$toforum_id.'/attaches-'.$newtopic_id.'.php';
      			@copy($oldattachesfile,$newattachesfile);
      			@chmod($newattachesfile,$exbb['ch_files']);
    		}
            //topic email trackfile
    		$oldtrackfile = $exbb['home_path'].'forum'.$fromforum_id.'/'.$oldtopic_id.'-m.php';
    		if (file_exists($oldtrackfile)) {
      			$newtrackfile = $exbb['home_path'].'forum'.$toforum_id.'/'.$newtopic_id.'-m.php';
      			@copy($oldtrackfile,$newtrackfile);
      			@chmod($newtrackfile,$exbb['ch_files']);
    		}
            //poll file
    		$oldpollfile = $exbb['home_path'].'forum'.$fromforum_id.'/'.$oldtopic_id.'-poll.php';
    		if (file_exists($oldpollfile)) {
      			$newpollfile = $exbb['home_path'].'forum'.$toforum_id.'/'.$newtopic_id.'-poll.php';
      			@copy($oldpollfile,$newpollfile);
      			@chmod($newpollfile,$exbb['ch_files']);
    		}

            $fp_fromlist = NULL; $fromlistfile = $exbb['home_path'].'forum'.$fromforum_id.'/list.php';
            $fromlist = Get_File_Data($fp_fromlist,$fromlistfile);

    		$tolist[$newtopic_id] = $fromlist[$oldtopic_id];
            $tolist[$newtopic_id]['id'] = $newtopic_id;
			$tolist[$newtopic_id]['fid'] = $toforum_id;

    		if ($vars['leavemessage'] == 'yes') {
                $fromlist[$oldtopic_id]['state'] = 'moved';
      			$fromlist[$oldtopic_id]['movedid'] = $toforum_id.':'.$newtopic_id;

      			include ('./data/boardstats.php');
      			$exbb['totalthreads']++;
          		$exbb['totalposts'] += $fromlist[$oldtopic_id]['posts'];
      			save_statfile();
			} else {
            		#XXXXXXXXXXXXXXXX -    xxxxxxxxxxxx
                   	$fp_pinned = NULL; $pinnedfile = $exbb['home_path'].'forum'.$fromforum_id.'/_pinned.phpp';
            		$pinned = Get_File_Data($fp_pinned,$pinnedfile);
                    if (isset($pinned[$oldtopic_id])){
                        unset($pinned[$oldtopic_id]);
                    }
                    save_opened_file($fp_pinned,$pinned);
                    #XXXXXXXXXXXXXXXX -    xxxxxxxxxxxx
      				$allforums[$fromforum_id]['posts'] -= $fromlist[$oldtopic_id]['posts'];
      				$allforums[$fromforum_id]['topics']--;

                    @unlink($oldtopicfile);
                    @unlink($oldattachesfile);
                    @unlink($oldtrackfile);
                    @unlink($oldpollfile);

      				unset($fromlist[$oldtopic_id]);
   			}

   			uasort ($fromlist, 'sort_by_postdate');
   			save_opened_file($fp_fromlist,$fromlist);

   			uasort ($tolist, 'sort_by_postdate');
   			save_opened_file($fp_tolist,$tolist);
   			@chmod($tolistfile,$exbb['ch_files']);

   			$allforums[$toforum_id]['topics']++;
   			$allforums[$toforum_id]['posts'] += $tolist[$newtopic_id]['posts'];

   			reset($tolist);
  	 		$first_key = key($tolist);
   			$allforums[$toforum_id]['last_post'] 		= $tolist[$first_key]['name'];
   			$allforums[$toforum_id]['last_post_id'] 	= $first_key;
   			$allforums[$toforum_id]['last_poster'] 		= $tolist[$first_key]['poster'];
   			$allforums[$toforum_id]['last_time'] 		= $tolist[$first_key]['postdate'];

   			reset($fromlist);
   			$first_key = key($fromlist);
   			$allforums[$fromforum_id]['last_post'] 		= $fromlist[$first_key]['name'];
   			$allforums[$fromforum_id]['last_post_id'] 	= $first_key;
   			$allforums[$fromforum_id]['last_poster'] 	= $fromlist[$first_key]['poster'];
   			$allforums[$fromforum_id]['last_time'] 		= $fromlist[$first_key]['postdate'];

   			save_opened_file($fp_allforums,$allforums);

   			unset($tolist,$allforums,$fromlist);

            /* ////  For fix zeros bugs  //// */
        	clearstatcache();
        	send_bugs(__FILE__,__LINE__,array($allforumsfile,$tolistfile,$fromlistfile),12);
        	/* ////  For fix zeros bugs  //// */

            $title_page = $exbb['boardname'].' :: '.$lang['Topic_moved'];
   			$ok_title = $lang['Topic_moved'];
   			$relocurl = 'forums.php?forum='.$fromforum_id;
   			$url1 = '<li><a href="forums.php?forum='.$fromforum_id.'">'.$lang['Go_to_old'].'</a>';
   			$url2 = '<li><a href="forums.php?forum='.$toforum_id.'">'.$lang['Go_to_new'].'</a>';
   			$url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
   			include('./templates/'.$exbb['default_style'].'all_header.tpl');
   			include('./templates/'.$exbb['default_style'].'postok.tpl');
   			include('./templates/'.$exbb['default_style'].'footer.tpl');
		} else {# end clear to move if
        		fclose($fp_allforums);
				$jumphtml = '<option value="">'.$lang['Choose_forum']."\n";
     			unset($allforums[$fromforum_id]);
     			foreach($allforums as $forumid=>$val){
             			if ($val['catid'] != $lastcategoryplace) { #start if $categoryplace
                 			$jumphtml .= '<option value="">'."\n";
                 			$jumphtml .= '<option class=forumline value="">-- &nbsp; '.$val['catname']."\n";
                 			$jumphtml .= '<option value="'.$forumid.'"> '.$val['name']."\n";
             			} else {
                 				$jumphtml .= '<option value="'.$forumid.'"> '.$val['name']."\n";
             			}
             			$lastcategoryplace = $val['catid'];
     			}

     			$title_page = $exbb['boardname'].' :: '.$lang['Topic_moving'];
     			include('admin/all_header.tpl');
     			include('admin/movetopic.tpl');
     			include('page_tail_admin.php');
		} # end else
} # end movetopic

function restore() {
		global $exbb,$vars,$lang;

  		$inforum = $vars['forum'];
  		$intopic = $vars['topic'];

        $forum = get_file($exbb['home_path'].'data/allforums.php',FALSE);
        if (!isset($forum[$inforum])) error($lang['Main_msg'],$lang['Dont_chg_url']);
  		$forumname = $forum[$inforum]['name'];
  		unset($forum);

  		$fp_topic = NULL; $topicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd.php';
        if (!file_exists($topicfile))  error($lang['Main_msg'],$lang['Dont_chg_url']);
  		$url = $exbb['boardurl'].'/topic.php?forum='.$inforum.'&topic='.$intopic;

		$topic = Get_File_Data($fp_topic,$topicfile,FALSE);

      	ksort($topic,SORT_NUMERIC);
      	reset($topic);
      	$t_date = key($topic);
      	$t_name = isset($topic[$t_date]['name']) ? $topic[$t_date]['name'] : '';
      	$t_desc = isset($topic[$t_date]['desc']) ? $topic[$t_date]['desc'] : '';
      	$t_author_id = $topic[$t_date]['p_id'] ? $topic[$t_date]['p_id'] : 0;
      	$t_author = getmember($t_author_id);
      	$t_author = ($t_author) ? $t_author['name'] : false;
        $t_post = $topic[$t_date]['post'];
        $t_poll = isset_poll($inforum,$intopic);
        $t_state = $topic[$t_date]['state'];
        $t_movedid = ($t_state == 'moved') ? $topic[$t_date]['movedid']:FALSE;
      	$posts = count($topic) - 1;
      	$time = date("d-m-Y H:i:s",$t_date-$exbb['usertime']*3600);
      	$files = 1;
      	$file = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd';
      	while (file_exists($file.$files.'.php') ) $files++;
      	$files--;
      	$note = $lang['recover_btn'];
      	if ( $files > 0 ) $note .= $lang['recover_note'];


  		if (!isset($vars['check'])) {
            fclose($fp_topic);
    		unset($topic);
    		$title_page = $exbb['boardname'].' :: '.$lang['top_recover'];
    		$t_author = ($t_author) ? $t_author : $lang['Unreg'];
    		include('./templates/'.$exbb['default_style'].'all_header.tpl');
    		include('./templates/'.$exbb['default_style'].'logos.tpl');
    		include('./templates/'.$exbb['default_style'].'top_restore.tpl');
    		include('./templates/'.$exbb['default_style'].'footer.tpl');
  		} else {
      			$topic[$t_date]['name'] = $vars['name'];
      			if (!empty($vars['desc'])) $topic[$t_date]['desc'] = $vars['desc'];
                save_opened_file($fp_topic,$topic);
      			end($topic);
      			$last_key = key($topic);
      			$last_id = isset($topic[$last_key]['p_id']) ? $topic[$last_key]['p_id'] : false;
      			unset($topic);

  				$fp_list = NULL; $listfile = $exbb['home_path'].'forum'.$inforum.'/list.php';
                $list = Get_File_Data($fp_list,$listfile,FALSE);

      			if ( $files > 0 ) {
          			$extmode = array();
          			$extmode[0] = $posts;
          			$list[$intopic]['fls'] = $files;
          			$list[$intopic]['ext'] = serialize($extmode);
          			$topicsfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$files.'.php';
          			if ( file_exists($topicsfile) ) {
              			$topic = get_file($topicsfile,FALSE);
              			ksort($topic,SORT_NUMERIC);
              			end($topic);
              			$last_key = key($topic);
              			$last_id = isset($topic[$last_key]['p_id']) ? $topic[$last_key]['p_id'] : 0;
          			}
      			}
                $views_data  = get_file($exbb['home_path'].'forum'.$inforum.'/views.php');
                $views = (isset($views_data[$intopic])) ? $views_data[$intopic]:0;
                unset($views_data);

      			$t_poster = getmember($last_id);
      			$t_poster = ($t_poster) ? $t_poster['name'] : false;

      			$list[$intopic]['name'] = $vars['name'];
                $list[$intopic]['id'] = $intopic;
                $list[$intopic]['fid'] = $inforum;
      			if (!empty($vars['desc'])) $list[$intopic]['desc'] = $vars['desc'];
      			$list[$intopic]['state'] = $t_state;
      			$list[$intopic]['posts'] = $posts;
      			$list[$intopic]['author'] = $t_author;
      			$list[$intopic]['a_id'] = $t_author_id;
      			$list[$intopic]['date'] = $t_date;
      			$list[$intopic]['poster'] = $t_poster;
      			$list[$intopic]['p_id'] = $last_id;
      			$list[$intopic]['postdate'] = $last_key;
      			$list[$intopic]['views'] = $views;
      			if ($t_poll === TRUE) $list[$intopic]['poll'] = true;
                if($t_state == 'moved'){$list[$intopic]['movedid'] = $t_movedid;}
      			#uasort ($list, 'sort_by_postdate');
      			save_opened_file($fp_list,$list);
      			@chmod($filetoopen,$exbb['ch_files']);
      			unset($list);

      			$relocurl = ( $files > 0 ) ? 'topic.php?forum='.$inforum.'&topic='.$intopic : 'forums.php?forum='.$inforum;

                /* ////  For fix zeros bugs  //// */
        		clearstatcache();
        		send_bugs(__FILE__,__LINE__,array($topicfile,$listfile),13);
        		/* ////  For fix zeros bugs  //// */

      			$title_page = $exbb['boardname'].' :: '.$lang['top_recover'];
      			$ok_title = $lang['top_recovered'];
      			$url1 = '<li><a href=topic.php?forum='.$inforum.'&topic='.$intopic.'">'.$lang['Return_in_topic'].'</a>';
      			$url2 = '<li><a href="forums.php?forum='.$inforum.'">'.$lang['Return_in_forum'].'</a>';
      			$url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
      			include('./templates/'.$exbb['default_style'].'all_header.tpl');
      			include('./templates/'.$exbb['default_style'].'postok.tpl');
      			include('./templates/'.$exbb['default_style'].'footer.tpl');
  		}
} //func

function top_recount() { #start
		global $exbb,$vars,$lang;
        include('./language/' . $exbb['default_lang'] . '/lang_admin.php');

  		$inforum = $vars['forum'];
  		$intopic = $vars['topic'];
        $forum = get_file($exbb['home_path'].'data/allforums.php',FALSE);
        if (!isset($forum[$inforum])) error($lang['Info'],$lang['Stat_error']);
        unset($forum);

  		$postscount = 0;
  		$fp_list = NULL; $listfile = $exbb['home_path'].'forum'.$inforum.'/list.php';
        $list = Get_File_Data($fp_list,$listfile,FALSE);
        if (!isset($list[$intopic])){
            fclose($fp_list);
        	error($lang['Info'],$lang['Stat_error']);
        }

  		$topiccount = $list[$intopic]['posts'];
    	$extmode = (isset($list[$intopic]['ext']) ) ? unserialize($list[$intopic]['ext']) : array();
    	$y = (count($extmode)) ? $list[$intopic]['fls'] : false;
    	$topicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd.php';
    	$topic = get_file($topicfile,FALSE);
    	$postscount += count($topic);
    	if ($y) {
        	$extmode[0] = $postscount;
        	$topicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd';
        	for ($i=1; $i<=$y; $i++) {
            	$topic = get_file($topicfile.$i.'.php',FALSE);
            	$extmode[$i] = count($topic);
            	$postscount += $extmode[$i];
        	}
        	$list[$intopic]['ext'] = serialize($extmode);
    	}
    	$postscount--;
    	$list[$intopic]['posts'] = $postscount;
    	save_opened_file($fp_list,$list);
    	unset($list,$topic);
    	$info = "$lang[Now_stat]<br>$lang[Posts_total] <b>$topiccount</b><p>$lang[After_recount]<br>
               	 $lang[Posts_total] <b>$postscount</b>";
        /* ////  For fix zeros bugs  //// */
        clearstatcache();
        send_bugs(__FILE__,__LINE__,array($listfile),14);
        /* ////  For fix zeros bugs  //// */
    	error($lang['Counting_complete'],$info,'',0);
}

function poll_edit() {
		global $exbb,$lang,$vars,$inuser,$inmembmod;

   		if (empty($vars['forum']) || empty($vars['topic'])) error($lang['Poll'],$lang['Dont_chg_url']);
        $inforum = $vars['forum'];
        $intopic = $vars['topic'];
   		$forum = get_file($exbb['home_path'].'data/allforums.php',FALSE);
        if (!isset($forum[$inforum]))error($lang['Poll'],$lang['Edit_no']);
   		if ($inmembmod) {error($lang['Poll'],$lang['Edit_no']);}
   		unset($forum);

   		if ($vars['delpoll'] == 'yes') {
     		if (!isset($vars['check'])) {
       			$form = '<p><form action="postings.php" method="post">
            			<input type=hidden name="action" value="poll">
            			<input type=hidden name="delpoll" value="yes">
            			<input type=hidden name="forum" value="'.$inforum.'">
            			<input type=hidden name="topic" value="'.$intopic.'">
            			<input type=hidden name="check" value="1">'.$lang['Poll_delete'].'
            			<input class=button type=submit name=submit value='.$lang['yes'].'>
            			</form>';
            	error($lang['Poll'],$form,'',false);
     		} else {
       				$delpollfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-poll.php';
       				@unlink($delpollfile);

                    $fp_list = NULL; $listfile = $exbb['home_path'].'forum'.$inforum.'/list.php';
        			$list = Get_File_Data($fp_list,$listfile,FALSE);
        			if (!isset($list[$intopic])){
            			fclose($fp_list);
        				error($lang['Poll'],$lang['Edit_no']);
        			}
       				unset($list[$intopic]['poll']);
       				save_opened_file($fp_list,$list);

        			/* ////  For fix zeros bugs  //// */
        			clearstatcache();
        			send_bugs(__FILE__,__LINE__,array($listfile),15);
        			/* ////  For fix zeros bugs  //// */
       				$relocurl = 'topic.php?forum='.$inforum.'&topic='.$intopic.'&start=1';
       				$title_page = $exbb['boardname'].' :: '.$lang['Poll_deleted'];
       				$ok_title = $lang['Poll_deleted'];
       				$url1 = '<li><a href="topic.php?forum='.$inforum.'&topic='.$intopic.'">'.$lang['Return_in_topic'].'</a> ';
       				$url2 = '<li><a href="forums.php?forum='.$inforum.'">'.$lang['Return_in_forum'].'</a>';
       				$url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
       				include('./templates/'.$exbb['default_style'].'all_header.tpl');
       				include('./templates/'.$exbb['default_style'].'postok.tpl');
       				include('./templates/'.$exbb['default_style'].'footer.tpl');
     		}
  		} else {
				$fp_poll = NULL; $pollfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-poll.php';
    			$poll_data = Get_File_Data($fp_poll,$pollfile,FALSE);
    			$poll_chces = unserialize($poll_data['choices']);

    			$polls_new = explode( '<br>', $vars['pollansw'] );

    			$vote_count = 0;
    			$poll_id = 0;
    			if ((count($polls_new) < count($poll_chces)) || isset($vars['respoll'])) {
      				$poll_data['votes'] = 0;
      				$poll_data['ids'] = serialize(array());
    			}

    			foreach ($polls_new as $choice) {
      					if ($choice == '') continue;

       					$votes = (isset($poll_chces[$poll_id][2])) ? $poll_chces[$poll_id][2] : 0;
       					$votes = (isset($vars['respoll'])) ? 0 : $votes;
       					$vote_count += $votes;
       					$poll_array[] = array( $poll_id , $choice, $votes );
       					$poll_id++;
    			}

    			if ($poll_id > 10 || $poll_id < 2) error($lang['Poll'],$lang['Poll_error']);

    			$poll = array();

    			$poll_data['pollname'] = $vars['pollname'];
    			$poll_data['choices'] = serialize($poll_array);
    			$poll_data['votes'] = $vote_count;
    			save_opened_file($fp_poll,$poll_data);

    			$relocurl = 'topic.php?forum='.$inforum.'&topic='.$intopic.'&start=1';
    			$title_page = $exbb['boardname'].' :: '.$lang['Edit_complete'];
    			$ok_title = $lang['Edit_complete'];
    			$url1 = '<li><a href="topic.php?forum='.$inforum.'&topic='.$intopic.'">'.$lang['Return_in_topic'].'</a> ';
    			$url2 = '<li><a href="forums.php?forum='.$inforum.'">'.$lang['Return_in_forum'].'</a>';
    			$url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
    			include('./templates/'.$exbb['default_style'].'all_header.tpl');
    			include('./templates/'.$exbb['default_style'].'postok.tpl');
    			include('./templates/'.$exbb['default_style'].'footer.tpl');
		}
  		return;
}

function un_lockthread($mode) {
		global $exbb,$lang,$vars,$inuser;

        $inforum = $vars['forum'];
        $intopic = $vars['topic'];

        $forum = get_file($exbb['home_path'].'data/allforums.php',FALSE);
        if (!isset($forum[$inforum]))error($lang['Topic_closing'],$lang['Edit_no']);

    	$inmembmod = moderator($inforum,$forum);

    	if ($inmembmod) {
        	$fp_list = NULL; $listfile = $exbb['home_path'].'forum'.$inforum.'/list.php';
        	$list = Get_File_Data($fp_list,$listfile,FALSE);
        	if (!isset($list[$intopic])){
            	fclose($fp_list);
        		error($lang['Topic_closing'],$lang['Edit_no']);
        	}
            $list[$intopic]['state'] = ($mode == 'lock')? 'closed':'open';
            save_opened_file($fp_list,$list);

            $fp_topic = NULL; $topicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd.php';
            $topic = Get_File_Data($fp_topic,$topicfile);
            ksort($topic,SORT_NUMERIC);
      		reset($topic);
      		$firstkey = key($topic);
            $topic[$firstkey]['state'] = $list[$intopic]['state'];
            save_opened_file($fp_topic,$topic);
            unset($topic);

            /* ////  For fix zeros bugs  //// */
        	clearstatcache();
        	send_bugs(__FILE__,__LINE__,array($listfile,$topicfile),16);
        	/* ////  For fix zeros bugs  //// */

        	$res = ($mode == 'lock') ? $lang['Topic_closed'] : $lang['Topic_unlock'];
        	$title_page = $exbb['boardname'].' :: '.$res;
        	$ok_title = $res;
        	$relocurl = 'forums.php?forum='.$inforum;
        	$url1 = '<li><a href="forums.php?forum='.$inforum.'">'.$lang['Back_in_forum'].'</a>';
        	$url2 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
        	$url3 = null;
        	include('./templates/'.$exbb['default_style'].'all_header.tpl');
        	include('./templates/'.$exbb['default_style'].'postok.tpl');
        	include('./templates/'.$exbb['default_style'].'footer.tpl');
   		} else {
   				error($lang['Topic_closing'],$lang['Edit_no']);
   		}
} # end un_lockthread

function un_pinthread($mode) {
		global $exbb,$lang,$vars,$inuser;

        $inforum = $vars['forum'];
        $intopic = $vars['topic'];

		$forum = get_file($exbb['home_path'].'data/allforums.php',FALSE);
        if (!isset($forum[$inforum])) error($lang['Topic_pinning'],$lang['Edit_no']);
        $inmembmod = moderator($inforum,$forum);
        unset($forum);
        $list = get_file($exbb['home_path'].'forum'.$inforum.'/list.php',FALSE);
        if (!isset($list[$intopic])) error($lang['Topic_pinning'],$lang['Edit_no']);
    	if ($inmembmod) {
			$fp_pinned = NULL; $_pinnedfile = $exbb['home_path'].'forum'.$inforum.'/_pinned.php';
            $sticked = Get_File_Data($fp_pinned,$_pinnedfile);

        	if ($mode == 'pin') {
          		$sticked[$intopic] = 1;
        	} else {
          			unset($sticked[$intopic]);
        	}
        	save_opened_file($fp_pinned,$sticked);

        	$res = ($mode == 'pin') ? ' ' : ' ';
        	$title_page = $exbb['boardname'].' :: '.$res;
        	$ok_title = $res;
        	$relocurl = 'forums.php?forum='.$inforum;
        	$url1 = '<li><a href="forums.php?forum='.$inforum.'">'.$lang['Back_in_forum'].'</a>';
        	$url2 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
        	$url3 = null;
        	include('./templates/'.$exbb['default_style'].'all_header.tpl');
        	include('./templates/'.$exbb['default_style'].'postok.tpl');
        	include('./templates/'.$exbb['default_style'].'footer.tpl');
   		} else {
   				error($lang['Topic_pinning'],$lang['Edit_no']);
   		}
} # end un_pinthread

function del_subscribed() {
		global $exbb,$lang,$vars,$inuser;

  		$inforum = $vars['forum'];
  		$intopic = $vars['topic'];
  		$inmembmod = moderator($inforum,$forum);

  		if ($inmembmod) {
    		$unlink_file = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-m.php';
    		@unlink($unlink_file);
    		$relocurl = 'topic.php?forum='.$inforum.'&topic='.$intopic.'&start=1';
    		$title_page = $exbb['boardname'].' :: '.$lang['Unsubscribed'];
    		$ok_title = $lang['Unsubscribed'];
    		$url1 = '<li><a href="topic.php?forum='.$inforum.'&topic='.$intopic.'">'.$lang['Return_in_topic'].'</a> ';
    		$url2 = '<li><a href="forums.php?forum='.$inforum.'">'.$lang['Return_in_forum'].'</a>';
    		$url3 = '<li><a href="index.php">'.$lang['Forums_return'].'</a>';
    		include('./templates/'.$exbb['default_style'].'all_header.tpl');
    		include('./templates/'.$exbb['default_style'].'postok.tpl');
    		include('./templates/'.$exbb['default_style'].'footer.tpl');
  		} else {
    			error($lang['Message_edit'],$lang['Edit_no']);
  		}
}

function preport() {
		global $exbb,$lang,$vars,$inuser,$mod_ids;
        if ($exbb['reged'] === FALSE)  error($lang['Posts_sent'],"        ");
        $inforum 	= (isset($vars['forum'])) ? intval($vars['forum']):0;
        $intopic 	= (isset($vars['topic'])) ? intval($vars['topic']):0;
		$key 		= (isset($vars['key'])) ? trim($vars['key']):"";
        if (empty($key)) error($lang['Main_msg'],$lang['Correct_post'],'',0);

        $allforums = get_file($allforumsfile = $exbb['home_path'].'data/allforums.php',FALSE);
        if (!array_key_exists($inforum,$allforums)) error($lang['Main_msg'],$lang['Correct_post'],'',0);
        $forumname = $allforums[$inforum]['name'];
        moderator($inforum,$allforums);
        unset($allforums);

   		$list = get_file($exbb['home_path'].'forum'.$inforum.'/list.php',FALSE);
   		if (!array_key_exists($intopic,$list)) error($lang['Main_msg'],$lang['Correct_post'],'',0);
        $topic_name = $list[$intopic]['name'];
        unset($list);

        list($postkey,$file_id,$start) = explode(':',$key);
        if ($postkey == "" || $start == "") error($lang['Main_msg'],$lang['Correct_post'],'',0);

		$intopicfile = $exbb['home_path'].'forum'.$inforum.'/'.$intopic.'-thd'.$file_id.'.php';
        if (!file_exists($intopicfile)) error($lang['Main_msg'],$lang['Correct_post'],'',0);

        $allmessages 	= get_file($intopicfile,FALSE);
        $p_id 			= $allmessages[$postkey]['p_id'];
        unset($allmessages);
        $userdata = getmember($p_id);

        if ($vars['request_method'] == 'post' && isset($vars['save']) && intval($vars['save']) === 1) {
        	if (count($mod_ids) == 0) $mod_ids[] = 1;
            $preporttext = (trim($_POST['preporttext']) == "") ? "" : $vars['preporttext'];
            if (!empty($preporttext)) $preporttext = '[quote:'.$exbb['member'].']'.$preporttext.'[/quote]';
            $username = ($userdata !== FALSE && is_array($userdata) && isset($userdata['name'])) ? "[url=".$exbb['boardurl']."profile.php?action=show&member=".$p_id."]".$userdata['name']."[/url]":'';


            $preport = " [url=".$exbb['boardurl']."profile.php?action=show&member=".$exbb['mem_id']."]".$exbb['member']."[/url],    ,  ".$username.",   [url=".$exbb['boardurl']."/topic.php?forum=".$inforum."&topic=".$intopic."&start=".$start."#".$postkey."]\"".$forumname." - ".$topic_name."\"[/url].\n  .\n\n";
            $preport .= $preporttext;
            $vars['msgtitle'] = "     ";
            foreach ($mod_ids as $u_id) {
                    $mes_id = time();
                    $fp_inbox = NULL; $inboxfile = $exbb['home_path'].'messages/'.$u_id.'-msg.php';
                    $inbox = Get_File_Data($fp_inbox,$inboxfile);
                    $inbox[$mes_id]['from']         = $exbb['member'];
                    $inbox[$mes_id]['title']        = $vars['msgtitle'];
                    $inbox[$mes_id]['msg']          = $preport;
                    $inbox[$mes_id]['frid']         = $exbb['mem_id'];
                    $inbox[$mes_id]['ymail']        = TRUE;
                    $inbox[$mes_id]['status']       = FALSE;
                    $inbox[$mes_id]['fmail']        = $inuser['mail'];
                    save_opened_file($fp_inbox,$inbox);
                    unset($inbox);
                    $fp_moder = NULL; $moderfile = $exbb['home_path'].'members/'.$u_id.'.php';
                    $moder = Get_File_Data($fp_moder,$moderfile,FALSE);
                    $moder['new_pm'] = TRUE;
                    //XXXXXXXXXXXXXXXXXX   E-mail    XXXXXXXXXXXXXXXXXXXXXXXXXX
                    if ($exbb['emailfunctions'] && $exbb['pmnewmes'] == 1 && $moder['sendnewpm']){
                        $membername = $moder['name'];
                        $searchpreg = array("#<br>#i","#\[q\]#i","#\[/q\]#i");
                		$replace    = array("\n","================  ================\n","\n=============   =============\n");
                		$pmtext     = preg_replace($searchpreg, $replace, $preport);
                		include('./modules/pmnewmes/pm_newmes.tpl');
                		$subject    = $lang['emsubnewpm'];
                		sendmail($exbb['boardname'],$exbb['adminemail'],$email,$subject,$moder['mail']);
                    }
                    //XXXXXXXXXXXXXXXXXX   E-mail    XXXXXXXXXXXXXXXXXXXXXXXXXX
                    unset($moder);
			}
			error($lang['Main_msg'],"!      .","<meta http-equiv='refresh' content='3; url=topic.php?forum=".$inforum."&topic=".$intopic."&start=".$start."#".$postkey."'>",0);
        } else {
                $username = ($userdata !== FALSE && is_array($userdata) && isset($userdata['name'])) ?$userdata['name']:'';
				$title_page = $exbb['boardname'].' ::   ';
        		include('./templates/'.$exbb['default_style'].'all_header.tpl');
        		include('./templates/'.$exbb['default_style'].'post_report.tpl');
        		include('./templates/'.$exbb['default_style'].'footer.tpl');
        }
}
?>
