<?php
/****************************************************************************
* ExBB v.1.1                                                              	*
* Copyright (c) 2002-20 by Alexander Subhankulov aka Warlock            	*
*                                                                         	*
* http://www.exbb.revansh.com                                             	*
* email: admin@exbb.revansh.com                                           	*
*                                                                         	*
****************************************************************************/
/****************************************************************************
*                                                                         	*
*   This program is free software; you can redistribute it and/or modify  	*
*   it under the terms of the GNU General Public License as published by  	*
*   the Free Software Foundation; either version 2 of the License, or     	*
*   (at your option) any later version.                                   	*
*                                                                         	*
****************************************************************************/
include('common.php');

$vars = parsed_vars();
include('./language/' . $exbb['default_lang'] . '/lang_rules.php');

$count = (is_array($rules)) ? count($rules) : 0;

if ($count) {
    $rulestitle = $lang['rules_topic'];
    foreach ($rules as $id=>$info) {
       $topic = $info['rules'];
       $desc = $info['desc'];
       include('./templates/'.$exbb['default_style'].'rules_data.tpl');
       $color = ( !($id % 2) ) ? 'row1' : 'row2';
    }
} else {
     	$rules_topics = "<center>  </center>";
     	$rules_content = null;
}
$title_page = $exbb['boardname'].' :: '.$lang['Forum_rules'];
include('./templates/'.$exbb['default_style'].'all_header.tpl');
include('./templates/'.$exbb['default_style'].'logos.tpl');
include('./templates/'.$exbb['default_style'].'rules.tpl');
include('./templates/'.$exbb['default_style'].'footer.tpl');
include('page_tail.php');
?>
